/* DeviceRow.c generated by valac 0.56.13, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "bluetooth.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];
typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED
} BluetoothDeviceRowStatus;

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL,
	BLUETOOTH_DEVICE_ROW_NUM_SIGNALS
};
static guint bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkButton* forget_button;
	GtkImage* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	BluetoothServicesDevice* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	BluetoothServicesDevice* _tmp9_;
	GError* _vala1_e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	BluetoothServicesDevice* _tmp12_;
	GError* _vala2_e;
	GtkImage* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static gboolean _bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self);
static gboolean __bluetooth_device_row___lambda26__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static GType bluetooth_device_row_get_type_once (void);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}

static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result;
#line 39 "../src/DeviceRow.vala"
	switch (self) {
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
#line 186 "DeviceRow.c"
		{
			gchar* _tmp0_;
#line 41 "../src/DeviceRow.vala"
			_tmp0_ = g_strdup (_ ("Available"));
#line 41 "../src/DeviceRow.vala"
			result = _tmp0_;
#line 41 "../src/DeviceRow.vala"
			return result;
#line 195 "DeviceRow.c"
		}
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
#line 199 "DeviceRow.c"
		{
			gchar* _tmp1_;
#line 43 "../src/DeviceRow.vala"
			_tmp1_ = g_strdup (_ ("Pairing…"));
#line 43 "../src/DeviceRow.vala"
			result = _tmp1_;
#line 43 "../src/DeviceRow.vala"
			return result;
#line 208 "DeviceRow.c"
		}
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 212 "DeviceRow.c"
		{
			gchar* _tmp2_;
#line 45 "../src/DeviceRow.vala"
			_tmp2_ = g_strdup (_ ("Connected"));
#line 45 "../src/DeviceRow.vala"
			result = _tmp2_;
#line 45 "../src/DeviceRow.vala"
			return result;
#line 221 "DeviceRow.c"
		}
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 225 "DeviceRow.c"
		{
			gchar* _tmp3_;
#line 47 "../src/DeviceRow.vala"
			_tmp3_ = g_strdup (_ ("Connecting…"));
#line 47 "../src/DeviceRow.vala"
			result = _tmp3_;
#line 47 "../src/DeviceRow.vala"
			return result;
#line 234 "DeviceRow.c"
		}
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 238 "DeviceRow.c"
		{
			gchar* _tmp4_;
#line 49 "../src/DeviceRow.vala"
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
#line 49 "../src/DeviceRow.vala"
			result = _tmp4_;
#line 49 "../src/DeviceRow.vala"
			return result;
#line 247 "DeviceRow.c"
		}
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 39 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
#line 253 "DeviceRow.c"
		{
			gchar* _tmp5_;
#line 52 "../src/DeviceRow.vala"
			_tmp5_ = g_strdup (_ ("Unable to Connect"));
#line 52 "../src/DeviceRow.vala"
			result = _tmp5_;
#line 52 "../src/DeviceRow.vala"
			return result;
#line 262 "DeviceRow.c"
		}
		default:
		{
			gchar* _tmp6_;
#line 54 "../src/DeviceRow.vala"
			_tmp6_ = g_strdup (_ ("Not Connected"));
#line 54 "../src/DeviceRow.vala"
			result = _tmp6_;
#line 54 "../src/DeviceRow.vala"
			return result;
#line 273 "DeviceRow.c"
		}
	}
}

static GType
bluetooth_device_row_status_get_type_once (void)
{
	static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED", "unable-to-connect-paired"}, {0, NULL, NULL}};
	GType bluetooth_device_row_status_type_id;
	bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
	return bluetooth_device_row_status_type_id;
}

static GType
bluetooth_device_row_status_get_type (void)
{
	static volatile gsize bluetooth_device_row_status_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__once)) {
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = bluetooth_device_row_status_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_status_type_id__once, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__once;
}

BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
#line 65 "../src/DeviceRow.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 65 "../src/DeviceRow.vala"
	g_return_val_if_fail (adapter != NULL, NULL);
#line 66 "../src/DeviceRow.vala"
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
#line 65 "../src/DeviceRow.vala"
	return self;
#line 313 "DeviceRow.c"
}

BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
#line 65 "../src/DeviceRow.vala"
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
#line 322 "DeviceRow.c"
}

static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
#line 21 "../src/DeviceRow.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/DeviceRow.vala"
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
#line 334 "DeviceRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/DeviceRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 342 "DeviceRow.c"
}

static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
#line 21 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/DeviceRow.vala"
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
#line 21 "../src/DeviceRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/DeviceRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
#line 21 "../src/DeviceRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/DeviceRow.vala"
	_data_->self = _tmp0_;
#line 21 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked_co (_data_);
#line 366 "DeviceRow.c"
}

static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
#line 21 "../src/DeviceRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 376 "DeviceRow.c"
}

static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
#line 243 "../src/DeviceRow.vala"
	_data_ = _user_data_;
#line 243 "../src/DeviceRow.vala"
	_data_->_source_object_ = source_object;
#line 243 "../src/DeviceRow.vala"
	_data_->_res_ = _res_;
#line 243 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked_co (_data_);
#line 393 "DeviceRow.c"
}

static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
#line 239 "../src/DeviceRow.vala"
	switch (_data_->_state_) {
#line 239 "../src/DeviceRow.vala"
		case 0:
#line 403 "DeviceRow.c"
		goto _state_0;
#line 239 "../src/DeviceRow.vala"
		case 1:
#line 407 "DeviceRow.c"
		goto _state_1;
#line 239 "../src/DeviceRow.vala"
		case 2:
#line 411 "DeviceRow.c"
		goto _state_2;
#line 239 "../src/DeviceRow.vala"
		case 3:
#line 415 "DeviceRow.c"
		goto _state_3;
		default:
#line 239 "../src/DeviceRow.vala"
		g_assert_not_reached ();
#line 420 "DeviceRow.c"
	}
	_state_0:
#line 240 "../src/DeviceRow.vala"
	_data_->_tmp0_ = _data_->self->priv->_device;
#line 240 "../src/DeviceRow.vala"
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
#line 240 "../src/DeviceRow.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 240 "../src/DeviceRow.vala"
	if (!_data_->_tmp2_) {
#line 241 "../src/DeviceRow.vala"
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
#line 433 "DeviceRow.c"
		{
#line 243 "../src/DeviceRow.vala"
			_data_->_tmp3_ = _data_->self->priv->_device;
#line 243 "../src/DeviceRow.vala"
			_data_->_state_ = 1;
#line 243 "../src/DeviceRow.vala"
			bluetooth_services_device_pair (_data_->_tmp3_, bluetooth_device_row_button_clicked_ready, _data_);
#line 243 "../src/DeviceRow.vala"
			return FALSE;
#line 443 "DeviceRow.c"
			_state_1:
#line 243 "../src/DeviceRow.vala"
			bluetooth_services_device_pair_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 243 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 449 "DeviceRow.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 242 "../src/DeviceRow.vala"
			_data_->e = _data_->_inner_error0_;
#line 242 "../src/DeviceRow.vala"
			_data_->_inner_error0_ = NULL;
#line 245 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
#line 246 "../src/DeviceRow.vala"
			_data_->_tmp4_ = _data_->e;
#line 246 "../src/DeviceRow.vala"
			_data_->_tmp5_ = _data_->_tmp4_->message;
#line 246 "../src/DeviceRow.vala"
			g_critical ("DeviceRow.vala:246: %s", _data_->_tmp5_);
#line 242 "../src/DeviceRow.vala"
			_g_error_free0 (_data_->e);
#line 470 "DeviceRow.c"
		}
		__finally0:
#line 242 "../src/DeviceRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 242 "../src/DeviceRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 242 "../src/DeviceRow.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 242 "../src/DeviceRow.vala"
			g_object_unref (_data_->_async_result);
#line 242 "../src/DeviceRow.vala"
			return FALSE;
#line 483 "DeviceRow.c"
		}
	} else {
#line 248 "../src/DeviceRow.vala"
		_data_->_tmp6_ = _data_->self->priv->_device;
#line 248 "../src/DeviceRow.vala"
		_data_->_tmp7_ = bluetooth_services_device_get_connected (_data_->_tmp6_);
#line 248 "../src/DeviceRow.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 248 "../src/DeviceRow.vala"
		if (!_data_->_tmp8_) {
#line 249 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
#line 496 "DeviceRow.c"
			{
#line 251 "../src/DeviceRow.vala"
				_data_->_tmp9_ = _data_->self->priv->_device;
#line 251 "../src/DeviceRow.vala"
				_data_->_state_ = 2;
#line 251 "../src/DeviceRow.vala"
				bluetooth_services_device_connect (_data_->_tmp9_, bluetooth_device_row_button_clicked_ready, _data_);
#line 251 "../src/DeviceRow.vala"
				return FALSE;
#line 506 "DeviceRow.c"
				_state_2:
#line 251 "../src/DeviceRow.vala"
				bluetooth_services_device_connect_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 251 "../src/DeviceRow.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 512 "DeviceRow.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 250 "../src/DeviceRow.vala"
				_data_->_vala1_e = _data_->_inner_error0_;
#line 250 "../src/DeviceRow.vala"
				_data_->_inner_error0_ = NULL;
#line 253 "../src/DeviceRow.vala"
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED);
#line 254 "../src/DeviceRow.vala"
				_data_->_tmp10_ = _data_->_vala1_e;
#line 254 "../src/DeviceRow.vala"
				_data_->_tmp11_ = _data_->_tmp10_->message;
#line 254 "../src/DeviceRow.vala"
				g_critical ("DeviceRow.vala:254: %s", _data_->_tmp11_);
#line 250 "../src/DeviceRow.vala"
				_g_error_free0 (_data_->_vala1_e);
#line 533 "DeviceRow.c"
			}
			__finally1:
#line 250 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 250 "../src/DeviceRow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 250 "../src/DeviceRow.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 250 "../src/DeviceRow.vala"
				g_object_unref (_data_->_async_result);
#line 250 "../src/DeviceRow.vala"
				return FALSE;
#line 546 "DeviceRow.c"
			}
		} else {
#line 257 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
#line 551 "DeviceRow.c"
			{
#line 259 "../src/DeviceRow.vala"
				_data_->_tmp12_ = _data_->self->priv->_device;
#line 259 "../src/DeviceRow.vala"
				_data_->_state_ = 3;
#line 259 "../src/DeviceRow.vala"
				bluetooth_services_device_disconnect (_data_->_tmp12_, bluetooth_device_row_button_clicked_ready, _data_);
#line 259 "../src/DeviceRow.vala"
				return FALSE;
#line 561 "DeviceRow.c"
				_state_3:
#line 259 "../src/DeviceRow.vala"
				bluetooth_services_device_disconnect_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
#line 259 "../src/DeviceRow.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 567 "DeviceRow.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
#line 258 "../src/DeviceRow.vala"
				_data_->_vala2_e = _data_->_inner_error0_;
#line 258 "../src/DeviceRow.vala"
				_data_->_inner_error0_ = NULL;
#line 261 "../src/DeviceRow.vala"
				_data_->_tmp13_ = _data_->self->priv->state;
#line 261 "../src/DeviceRow.vala"
				g_object_set (_data_->_tmp13_, "icon-name", "user-busy", NULL);
#line 262 "../src/DeviceRow.vala"
				_data_->_tmp14_ = _data_->_vala2_e;
#line 262 "../src/DeviceRow.vala"
				_data_->_tmp15_ = _data_->_tmp14_->message;
#line 262 "../src/DeviceRow.vala"
				g_critical ("DeviceRow.vala:262: %s", _data_->_tmp15_);
#line 258 "../src/DeviceRow.vala"
				_g_error_free0 (_data_->_vala2_e);
#line 590 "DeviceRow.c"
			}
			__finally2:
#line 258 "../src/DeviceRow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 258 "../src/DeviceRow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 258 "../src/DeviceRow.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 258 "../src/DeviceRow.vala"
				g_object_unref (_data_->_async_result);
#line 258 "../src/DeviceRow.vala"
				return FALSE;
#line 603 "DeviceRow.c"
			}
		}
	}
#line 239 "../src/DeviceRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 239 "../src/DeviceRow.vala"
	if (_data_->_state_ != 0) {
#line 239 "../src/DeviceRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 239 "../src/DeviceRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 615 "DeviceRow.c"
		}
	}
#line 239 "../src/DeviceRow.vala"
	g_object_unref (_data_->_async_result);
#line 239 "../src/DeviceRow.vala"
	return FALSE;
#line 622 "DeviceRow.c"
}

static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 267 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 268 "../src/DeviceRow.vala"
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
#line 268 "../src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 268 "../src/DeviceRow.vala"
	if (!_tmp2_) {
#line 269 "../src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
#line 643 "DeviceRow.c"
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 270 "../src/DeviceRow.vala"
		_tmp3_ = self->priv->_device;
#line 270 "../src/DeviceRow.vala"
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
#line 270 "../src/DeviceRow.vala"
		_tmp5_ = _tmp4_;
#line 270 "../src/DeviceRow.vala"
		if (_tmp5_) {
#line 271 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
#line 658 "DeviceRow.c"
		} else {
#line 273 "../src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
#line 662 "DeviceRow.c"
		}
	}
}

static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
#line 277 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->state_label;
#line 278 "../src/DeviceRow.vala"
	_tmp1_ = bluetooth_device_row_status_to_string (status);
#line 278 "../src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 278 "../src/DeviceRow.vala"
	_tmp3_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp2_);
#line 278 "../src/DeviceRow.vala"
	_tmp4_ = _tmp3_;
#line 278 "../src/DeviceRow.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 278 "../src/DeviceRow.vala"
	_g_free0 (_tmp4_);
#line 278 "../src/DeviceRow.vala"
	_g_free0 (_tmp2_);
#line 279 "../src/DeviceRow.vala"
	_tmp5_ = self->priv->state;
#line 279 "../src/DeviceRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
#line 280 "../src/DeviceRow.vala"
	_tmp6_ = self->priv->state;
#line 280 "../src/DeviceRow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 282 "../src/DeviceRow.vala"
	switch (status) {
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
#line 708 "DeviceRow.c"
		{
			GtkButton* _tmp7_;
			GtkButton* _tmp8_;
			GtkLinkButton* _tmp9_;
			GtkImage* _tmp10_;
			GtkImage* _tmp11_;
			GtkButton* _tmp12_;
#line 284 "../src/DeviceRow.vala"
			_tmp7_ = self->priv->connect_button;
#line 284 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp7_, _ ("Pair"));
#line 285 "../src/DeviceRow.vala"
			_tmp8_ = self->priv->connect_button;
#line 285 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
#line 286 "../src/DeviceRow.vala"
			_tmp9_ = self->priv->settings_button;
#line 286 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 287 "../src/DeviceRow.vala"
			_tmp10_ = self->priv->state;
#line 287 "../src/DeviceRow.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
#line 288 "../src/DeviceRow.vala"
			_tmp11_ = self->priv->state;
#line 288 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
#line 289 "../src/DeviceRow.vala"
			_tmp12_ = self->priv->forget_button;
#line 289 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
#line 290 "../src/DeviceRow.vala"
			break;
#line 742 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
#line 746 "DeviceRow.c"
		{
			GtkButton* _tmp13_;
			GtkImage* _tmp14_;
			GtkLinkButton* _tmp15_;
			GtkButton* _tmp16_;
#line 292 "../src/DeviceRow.vala"
			_tmp13_ = self->priv->connect_button;
#line 292 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
#line 293 "../src/DeviceRow.vala"
			_tmp14_ = self->priv->state;
#line 293 "../src/DeviceRow.vala"
			g_object_set (_tmp14_, "icon-name", "user-away", NULL);
#line 294 "../src/DeviceRow.vala"
			_tmp15_ = self->priv->settings_button;
#line 294 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
#line 295 "../src/DeviceRow.vala"
			_tmp16_ = self->priv->forget_button;
#line 295 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp16_, FALSE);
#line 296 "../src/DeviceRow.vala"
			break;
#line 770 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 774 "DeviceRow.c"
		{
			GtkButton* _tmp17_;
			GtkButton* _tmp18_;
			GtkImage* _tmp19_;
			GtkLinkButton* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			GtkButton* _tmp24_;
			GtkButton* _tmp25_;
#line 298 "../src/DeviceRow.vala"
			_tmp17_ = self->priv->connect_button;
#line 298 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp17_, _ ("Disconnect"));
#line 299 "../src/DeviceRow.vala"
			_tmp18_ = self->priv->connect_button;
#line 299 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, TRUE);
#line 300 "../src/DeviceRow.vala"
			_tmp19_ = self->priv->state;
#line 300 "../src/DeviceRow.vala"
			g_object_set (_tmp19_, "icon-name", "user-available", NULL);
#line 301 "../src/DeviceRow.vala"
			_tmp20_ = self->priv->settings_button;
#line 301 "../src/DeviceRow.vala"
			_tmp21_ = gtk_link_button_get_uri (_tmp20_);
#line 301 "../src/DeviceRow.vala"
			_tmp22_ = _tmp21_;
#line 301 "../src/DeviceRow.vala"
			if (g_strcmp0 (_tmp22_, "") != 0) {
#line 804 "DeviceRow.c"
				GtkLinkButton* _tmp23_;
#line 302 "../src/DeviceRow.vala"
				_tmp23_ = self->priv->settings_button;
#line 302 "../src/DeviceRow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp23_, TRUE);
#line 810 "DeviceRow.c"
			}
#line 304 "../src/DeviceRow.vala"
			_tmp24_ = self->priv->forget_button;
#line 304 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, TRUE);
#line 305 "../src/DeviceRow.vala"
			_tmp25_ = self->priv->forget_button;
#line 305 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp25_, TRUE);
#line 306 "../src/DeviceRow.vala"
			break;
#line 822 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 826 "DeviceRow.c"
		{
			GtkButton* _tmp26_;
			GtkImage* _tmp27_;
			GtkLinkButton* _tmp28_;
			GtkButton* _tmp29_;
			GtkButton* _tmp30_;
#line 308 "../src/DeviceRow.vala"
			_tmp26_ = self->priv->connect_button;
#line 308 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, FALSE);
#line 309 "../src/DeviceRow.vala"
			_tmp27_ = self->priv->state;
#line 309 "../src/DeviceRow.vala"
			g_object_set (_tmp27_, "icon-name", "user-away", NULL);
#line 310 "../src/DeviceRow.vala"
			_tmp28_ = self->priv->settings_button;
#line 310 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 311 "../src/DeviceRow.vala"
			_tmp29_ = self->priv->forget_button;
#line 311 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, FALSE);
#line 312 "../src/DeviceRow.vala"
			_tmp30_ = self->priv->forget_button;
#line 312 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp30_, TRUE);
#line 313 "../src/DeviceRow.vala"
			break;
#line 855 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 859 "DeviceRow.c"
		{
			GtkButton* _tmp31_;
			GtkImage* _tmp32_;
			GtkLinkButton* _tmp33_;
			GtkButton* _tmp34_;
			GtkButton* _tmp35_;
#line 315 "../src/DeviceRow.vala"
			_tmp31_ = self->priv->connect_button;
#line 315 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, FALSE);
#line 316 "../src/DeviceRow.vala"
			_tmp32_ = self->priv->state;
#line 316 "../src/DeviceRow.vala"
			g_object_set (_tmp32_, "icon-name", "user-away", NULL);
#line 317 "../src/DeviceRow.vala"
			_tmp33_ = self->priv->settings_button;
#line 317 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
#line 318 "../src/DeviceRow.vala"
			_tmp34_ = self->priv->forget_button;
#line 318 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, FALSE);
#line 319 "../src/DeviceRow.vala"
			_tmp35_ = self->priv->forget_button;
#line 319 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp35_, TRUE);
#line 320 "../src/DeviceRow.vala"
			break;
#line 888 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
#line 892 "DeviceRow.c"
		{
			GtkButton* _tmp36_;
			GtkButton* _tmp37_;
			GtkImage* _tmp38_;
			GtkLinkButton* _tmp39_;
			GtkButton* _tmp40_;
			GtkButton* _tmp41_;
#line 322 "../src/DeviceRow.vala"
			_tmp36_ = self->priv->connect_button;
#line 322 "../src/DeviceRow.vala"
			gtk_button_set_label (_tmp36_, _ ("Connect"));
#line 323 "../src/DeviceRow.vala"
			_tmp37_ = self->priv->connect_button;
#line 323 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp37_, TRUE);
#line 324 "../src/DeviceRow.vala"
			_tmp38_ = self->priv->state;
#line 324 "../src/DeviceRow.vala"
			g_object_set (_tmp38_, "icon-name", "user-offline", NULL);
#line 325 "../src/DeviceRow.vala"
			_tmp39_ = self->priv->settings_button;
#line 325 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 326 "../src/DeviceRow.vala"
			_tmp40_ = self->priv->forget_button;
#line 326 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, TRUE);
#line 327 "../src/DeviceRow.vala"
			_tmp41_ = self->priv->forget_button;
#line 327 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp41_, TRUE);
#line 328 "../src/DeviceRow.vala"
			break;
#line 926 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 930 "DeviceRow.c"
		{
			GtkButton* _tmp42_;
			GtkImage* _tmp43_;
			GtkLinkButton* _tmp44_;
			GtkButton* _tmp45_;
#line 330 "../src/DeviceRow.vala"
			_tmp42_ = self->priv->connect_button;
#line 330 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp42_, TRUE);
#line 331 "../src/DeviceRow.vala"
			_tmp43_ = self->priv->state;
#line 331 "../src/DeviceRow.vala"
			g_object_set (_tmp43_, "icon-name", "user-busy", NULL);
#line 332 "../src/DeviceRow.vala"
			_tmp44_ = self->priv->settings_button;
#line 332 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp44_, FALSE);
#line 333 "../src/DeviceRow.vala"
			_tmp45_ = self->priv->forget_button;
#line 333 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp45_, FALSE);
#line 334 "../src/DeviceRow.vala"
			break;
#line 954 "DeviceRow.c"
		}
#line 282 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
#line 958 "DeviceRow.c"
		{
			GtkButton* _tmp46_;
			GtkImage* _tmp47_;
			GtkLinkButton* _tmp48_;
			GtkButton* _tmp49_;
			GtkButton* _tmp50_;
#line 336 "../src/DeviceRow.vala"
			_tmp46_ = self->priv->connect_button;
#line 336 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp46_, TRUE);
#line 337 "../src/DeviceRow.vala"
			_tmp47_ = self->priv->state;
#line 337 "../src/DeviceRow.vala"
			g_object_set (_tmp47_, "icon-name", "user-offline", NULL);
#line 338 "../src/DeviceRow.vala"
			_tmp48_ = self->priv->settings_button;
#line 338 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp48_, FALSE);
#line 339 "../src/DeviceRow.vala"
			_tmp49_ = self->priv->forget_button;
#line 339 "../src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp49_, TRUE);
#line 340 "../src/DeviceRow.vala"
			_tmp50_ = self->priv->forget_button;
#line 340 "../src/DeviceRow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp50_, TRUE);
#line 341 "../src/DeviceRow.vala"
			break;
#line 987 "DeviceRow.c"
		}
		default:
#line 282 "../src/DeviceRow.vala"
		break;
#line 992 "DeviceRow.c"
	}
#line 343 "../src/DeviceRow.vala"
	g_signal_emit (self, bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL], 0);
#line 996 "DeviceRow.c"
}

BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
#line 22 "../src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 22 "../src/DeviceRow.vala"
	result = _tmp0_;
#line 22 "../src/DeviceRow.vala"
	return result;
#line 1012 "DeviceRow.c"
}

static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
	BluetoothServicesDevice* old_value;
#line 22 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/DeviceRow.vala"
	old_value = bluetooth_device_row_get_device (self);
#line 22 "../src/DeviceRow.vala"
	if (old_value != value) {
#line 1026 "DeviceRow.c"
		BluetoothServicesDevice* _tmp0_;
#line 22 "../src/DeviceRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../src/DeviceRow.vala"
		_g_object_unref0 (self->priv->_device);
#line 22 "../src/DeviceRow.vala"
		self->priv->_device = _tmp0_;
#line 22 "../src/DeviceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
#line 1036 "DeviceRow.c"
	}
}

BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
#line 23 "../src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_adapter;
#line 23 "../src/DeviceRow.vala"
	result = _tmp0_;
#line 23 "../src/DeviceRow.vala"
	return result;
#line 1053 "DeviceRow.c"
}

static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
	BluetoothServicesAdapter* old_value;
#line 23 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/DeviceRow.vala"
	old_value = bluetooth_device_row_get_adapter (self);
#line 23 "../src/DeviceRow.vala"
	if (old_value != value) {
#line 23 "../src/DeviceRow.vala"
		self->priv->_adapter = value;
#line 23 "../src/DeviceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
#line 1071 "DeviceRow.c"
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 73 "../src/DeviceRow.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 73 "../src/DeviceRow.vala"
	return _data1_;
#line 1082 "DeviceRow.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 73 "../src/DeviceRow.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1092 "DeviceRow.c"
		BluetoothDeviceRow* self;
#line 73 "../src/DeviceRow.vala"
		self = _data1_->self;
#line 73 "../src/DeviceRow.vala"
		_g_object_unref0 (_data1_->label);
#line 73 "../src/DeviceRow.vala"
		_g_object_unref0 (_data1_->image);
#line 73 "../src/DeviceRow.vala"
		_g_object_unref0 (self);
#line 73 "../src/DeviceRow.vala"
		g_slice_free (Block1Data, _data1_);
#line 1104 "DeviceRow.c"
	}
}

static void
_bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                   GVariant* changed,
                                   gchar** invalid)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 190 "../src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 191 "../src/DeviceRow.vala"
	_tmp0_ = g_variant_type_new ("b");
#line 191 "../src/DeviceRow.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/DeviceRow.vala"
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
#line 191 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp1_);
#line 191 "../src/DeviceRow.vala"
	powered = _tmp3_;
#line 192 "../src/DeviceRow.vala"
	_tmp4_ = powered;
#line 192 "../src/DeviceRow.vala"
	if (_tmp4_ != NULL) {
#line 1137 "DeviceRow.c"
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 193 "../src/DeviceRow.vala"
		_tmp5_ = self->priv->_adapter;
#line 193 "../src/DeviceRow.vala"
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
#line 193 "../src/DeviceRow.vala"
		_tmp7_ = _tmp6_;
#line 193 "../src/DeviceRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
#line 194 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1151 "DeviceRow.c"
	}
#line 190 "../src/DeviceRow.vala"
	_g_variant_unref0 (powered);
#line 1155 "DeviceRow.c"
}

static void
__bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
#line 190 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda23_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties);
#line 1166 "DeviceRow.c"
}

static void
_bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                   GVariant* changed,
                                   gchar** invalid)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* name = NULL;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* icon = NULL;
	GVariantType* _tmp21_;
	GVariantType* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
#line 198 "../src/DeviceRow.vala"
	self = _data1_->self;
#line 198 "../src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 199 "../src/DeviceRow.vala"
	_tmp0_ = g_variant_type_new ("b");
#line 199 "../src/DeviceRow.vala"
	_tmp1_ = _tmp0_;
#line 199 "../src/DeviceRow.vala"
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
#line 199 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 199 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp1_);
#line 199 "../src/DeviceRow.vala"
	paired = _tmp3_;
#line 200 "../src/DeviceRow.vala"
	_tmp4_ = paired;
#line 200 "../src/DeviceRow.vala"
	if (_tmp4_ != NULL) {
#line 1219 "DeviceRow.c"
		BluetoothServicesDevice* _tmp5_;
#line 201 "../src/DeviceRow.vala"
		bluetooth_device_row_compute_status (self);
#line 202 "../src/DeviceRow.vala"
		_tmp5_ = self->priv->_device;
#line 202 "../src/DeviceRow.vala"
		bluetooth_services_device_connect (_tmp5_, NULL, NULL);
#line 203 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1229 "DeviceRow.c"
	}
#line 206 "../src/DeviceRow.vala"
	_tmp6_ = g_variant_type_new ("b");
#line 206 "../src/DeviceRow.vala"
	_tmp7_ = _tmp6_;
#line 206 "../src/DeviceRow.vala"
	_tmp8_ = g_variant_lookup_value (changed, "Connected", _tmp7_);
#line 206 "../src/DeviceRow.vala"
	_tmp9_ = _tmp8_;
#line 206 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp7_);
#line 206 "../src/DeviceRow.vala"
	connected = _tmp9_;
#line 207 "../src/DeviceRow.vala"
	_tmp10_ = connected;
#line 207 "../src/DeviceRow.vala"
	if (_tmp10_ != NULL) {
#line 208 "../src/DeviceRow.vala"
		bluetooth_device_row_compute_status (self);
#line 209 "../src/DeviceRow.vala"
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 1251 "DeviceRow.c"
	}
#line 212 "../src/DeviceRow.vala"
	_tmp11_ = g_variant_type_new ("s");
#line 212 "../src/DeviceRow.vala"
	_tmp12_ = _tmp11_;
#line 212 "../src/DeviceRow.vala"
	_tmp13_ = g_variant_lookup_value (changed, "Name", _tmp12_);
#line 212 "../src/DeviceRow.vala"
	_tmp14_ = _tmp13_;
#line 212 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp12_);
#line 212 "../src/DeviceRow.vala"
	name = _tmp14_;
#line 213 "../src/DeviceRow.vala"
	_tmp15_ = name;
#line 213 "../src/DeviceRow.vala"
	if (_tmp15_ != NULL) {
#line 1269 "DeviceRow.c"
		GtkLabel* _tmp16_;
		BluetoothServicesDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 214 "../src/DeviceRow.vala"
		_tmp16_ = _data1_->label;
#line 214 "../src/DeviceRow.vala"
		_tmp17_ = self->priv->_device;
#line 214 "../src/DeviceRow.vala"
		_tmp18_ = bluetooth_services_device_get_name (_tmp17_);
#line 214 "../src/DeviceRow.vala"
		_tmp19_ = _tmp18_;
#line 214 "../src/DeviceRow.vala"
		_tmp20_ = _tmp19_;
#line 214 "../src/DeviceRow.vala"
		gtk_label_set_label (_tmp16_, _tmp20_);
#line 214 "../src/DeviceRow.vala"
		_g_free0 (_tmp20_);
#line 1289 "DeviceRow.c"
	}
#line 217 "../src/DeviceRow.vala"
	_tmp21_ = g_variant_type_new ("s");
#line 217 "../src/DeviceRow.vala"
	_tmp22_ = _tmp21_;
#line 217 "../src/DeviceRow.vala"
	_tmp23_ = g_variant_lookup_value (changed, "Icon", _tmp22_);
#line 217 "../src/DeviceRow.vala"
	_tmp24_ = _tmp23_;
#line 217 "../src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp22_);
#line 217 "../src/DeviceRow.vala"
	icon = _tmp24_;
#line 218 "../src/DeviceRow.vala"
	_tmp25_ = icon;
#line 218 "../src/DeviceRow.vala"
	if (_tmp25_ != NULL) {
#line 1307 "DeviceRow.c"
		gchar* _tmp26_ = NULL;
		BluetoothServicesDevice* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GtkImage* _tmp31_;
#line 219 "../src/DeviceRow.vala"
		_tmp27_ = self->priv->_device;
#line 219 "../src/DeviceRow.vala"
		_tmp28_ = bluetooth_services_device_get_icon (_tmp27_);
#line 219 "../src/DeviceRow.vala"
		_tmp29_ = _tmp28_;
#line 219 "../src/DeviceRow.vala"
		_tmp26_ = _tmp29_;
#line 219 "../src/DeviceRow.vala"
		if (_tmp26_ == NULL) {
#line 1323 "DeviceRow.c"
			gchar* _tmp30_;
#line 219 "../src/DeviceRow.vala"
			_tmp30_ = g_strdup ("bluetooth");
#line 219 "../src/DeviceRow.vala"
			_g_free0 (_tmp26_);
#line 219 "../src/DeviceRow.vala"
			_tmp26_ = _tmp30_;
#line 1331 "DeviceRow.c"
		}
#line 219 "../src/DeviceRow.vala"
		_tmp31_ = _data1_->image;
#line 219 "../src/DeviceRow.vala"
		g_object_set (_tmp31_, "icon-name", _tmp26_, NULL);
#line 218 "../src/DeviceRow.vala"
		_g_free0 (_tmp26_);
#line 1339 "DeviceRow.c"
	}
#line 198 "../src/DeviceRow.vala"
	_g_variant_unref0 (icon);
#line 198 "../src/DeviceRow.vala"
	_g_variant_unref0 (name);
#line 198 "../src/DeviceRow.vala"
	_g_variant_unref0 (connected);
#line 198 "../src/DeviceRow.vala"
	_g_variant_unref0 (paired);
#line 1349 "DeviceRow.c"
}

static void
__bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
#line 198 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda24_ (self, changed_properties, invalidated_properties);
#line 1360 "DeviceRow.c"
}

static void
_bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 224 "../src/DeviceRow.vala"
	bluetooth_device_row_button_clicked (self, NULL, NULL);
#line 226 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 226 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->_device;
#line 226 "../src/DeviceRow.vala"
	_tmp2_ = bluetooth_services_device_get_paired (_tmp1_);
#line 226 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 226 "../src/DeviceRow.vala"
	bluetooth_services_device_set_trusted (_tmp0_, _tmp3_);
#line 1382 "DeviceRow.c"
}

static void
__bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 223 "../src/DeviceRow.vala"
	_bluetooth_device_row___lambda25_ ((BluetoothDeviceRow*) self);
#line 1391 "DeviceRow.c"
}

static gboolean
_bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self)
{
	GError* _inner_error0_ = NULL;
	{
		BluetoothServicesAdapter* _tmp0_;
		BluetoothServicesDevice* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
#line 231 "../src/DeviceRow.vala"
		_tmp0_ = self->priv->_adapter;
#line 231 "../src/DeviceRow.vala"
		_tmp1_ = self->priv->_device;
#line 231 "../src/DeviceRow.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_dbus_proxy_get_type (), GDBusProxy), "g-object-path", &_tmp2_, NULL);
#line 231 "../src/DeviceRow.vala"
		_tmp3_ = _tmp2_;
#line 231 "../src/DeviceRow.vala"
		_tmp4_ = _tmp3_;
#line 231 "../src/DeviceRow.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 231 "../src/DeviceRow.vala"
		_tmp6_ = _tmp5_;
#line 231 "../src/DeviceRow.vala"
		bluetooth_services_adapter_remove_device (_tmp0_, _tmp6_, &_inner_error0_);
#line 231 "../src/DeviceRow.vala"
		_g_free0 (_tmp6_);
#line 231 "../src/DeviceRow.vala"
		_g_free0 (_tmp4_);
#line 231 "../src/DeviceRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1428 "DeviceRow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 230 "../src/DeviceRow.vala"
		e = _inner_error0_;
#line 230 "../src/DeviceRow.vala"
		_inner_error0_ = NULL;
#line 233 "../src/DeviceRow.vala"
		_tmp7_ = e;
#line 233 "../src/DeviceRow.vala"
		_tmp8_ = _tmp7_->message;
#line 233 "../src/DeviceRow.vala"
		g_debug ("DeviceRow.vala:233: Forget bluetooth device failed: %s", _tmp8_);
#line 230 "../src/DeviceRow.vala"
		_g_error_free0 (e);
#line 1450 "DeviceRow.c"
	}
	__finally0:
#line 230 "../src/DeviceRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1455 "DeviceRow.c"
		gboolean _tmp9_ = FALSE;
#line 230 "../src/DeviceRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/DeviceRow.vala"
		g_clear_error (&_inner_error0_);
#line 230 "../src/DeviceRow.vala"
		return _tmp9_;
#line 1463 "DeviceRow.c"
	}
}

static gboolean
__bluetooth_device_row___lambda26__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                    GdkEventButton* event,
                                                                    gpointer self)
{
	gboolean result;
	result = _bluetooth_device_row___lambda26_ ((BluetoothDeviceRow*) self);
#line 229 "../src/DeviceRow.vala"
	return result;
#line 1476 "DeviceRow.c"
}

static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block1Data* _data1_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp12_;
	GtkOverlay* _tmp13_;
	BluetoothServicesDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	gchar* device_name = NULL;
	BluetoothServicesDevice* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLinkButton* _tmp55_;
	GtkLinkButton* _tmp56_;
	GtkLinkButton* _tmp57_;
	GtkImage* _tmp58_;
	GtkImage* _tmp59_;
	GtkLinkButton* _tmp60_;
	GtkLinkButton* _tmp61_;
	GtkLinkButton* _tmp62_;
	GtkLinkButton* _tmp63_;
	GtkLinkButton* _tmp64_;
	gchar* _tmp65_;
	GtkButton* _tmp66_ = NULL;
	GtkButton* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkSizeGroup* _tmp71_;
	GtkButton* _tmp72_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkOverlay* _tmp78_;
	GtkGrid* _tmp79_;
	GtkLabel* _tmp80_;
	GtkGrid* _tmp81_;
	GtkLabel* _tmp82_;
	GtkGrid* _tmp83_;
	GtkLinkButton* _tmp84_;
	GtkGrid* _tmp85_;
	GtkButton* _tmp86_;
	GtkGrid* _tmp87_;
	GtkButton* _tmp88_;
	GtkGrid* _tmp89_;
	BluetoothServicesDevice* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GQuark _tmp95_ = 0U;
#line 163 "../src/DeviceRow.vala"
	static GQuark _tmp94_label0 = 0;
#line 163 "../src/DeviceRow.vala"
	static GQuark _tmp94_label1 = 0;
#line 163 "../src/DeviceRow.vala"
	static GQuark _tmp94_label2 = 0;
#line 163 "../src/DeviceRow.vala"
	static GQuark _tmp94_label3 = 0;
#line 163 "../src/DeviceRow.vala"
	static GQuark _tmp94_label4 = 0;
#line 1571 "DeviceRow.c"
	BluetoothServicesAdapter* _tmp106_;
	gboolean _tmp107_;
	gboolean _tmp108_;
	BluetoothServicesAdapter* _tmp109_;
	BluetoothServicesDevice* _tmp110_;
	GtkButton* _tmp111_;
	GtkButton* _tmp112_;
#line 73 "../src/DeviceRow.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
#line 73 "../src/DeviceRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 73 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 73 "../src/DeviceRow.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 73 "../src/DeviceRow.vala"
	_data1_->_ref_count_ = 1;
#line 73 "../src/DeviceRow.vala"
	_data1_->self = g_object_ref (self);
#line 74 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->_device;
#line 74 "../src/DeviceRow.vala"
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
#line 74 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 74 "../src/DeviceRow.vala"
	_tmp0_ = _tmp3_;
#line 74 "../src/DeviceRow.vala"
	if (_tmp0_ == NULL) {
#line 1601 "DeviceRow.c"
		gchar* _tmp4_;
#line 74 "../src/DeviceRow.vala"
		_tmp4_ = g_strdup ("bluetooth");
#line 74 "../src/DeviceRow.vala"
		_g_free0 (_tmp0_);
#line 74 "../src/DeviceRow.vala"
		_tmp0_ = _tmp4_;
#line 1609 "DeviceRow.c"
	}
#line 74 "../src/DeviceRow.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 74 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp5_);
#line 74 "../src/DeviceRow.vala"
	_data1_->image = _tmp5_;
#line 76 "../src/DeviceRow.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 76 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp6_);
#line 76 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 76 "../src/DeviceRow.vala"
	self->priv->state = _tmp6_;
#line 77 "../src/DeviceRow.vala"
	_tmp7_ = self->priv->state;
#line 77 "../src/DeviceRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
#line 78 "../src/DeviceRow.vala"
	_tmp8_ = self->priv->state;
#line 78 "../src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 80 "../src/DeviceRow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 80 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp9_);
#line 80 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 80 "../src/DeviceRow.vala"
	self->priv->state_label = _tmp9_;
#line 81 "../src/DeviceRow.vala"
	_tmp10_ = self->priv->state_label;
#line 81 "../src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
#line 82 "../src/DeviceRow.vala"
	_tmp11_ = self->priv->state_label;
#line 82 "../src/DeviceRow.vala"
	gtk_label_set_use_markup (_tmp11_, TRUE);
#line 84 "../src/DeviceRow.vala"
	_tmp12_ = (GtkOverlay*) gtk_overlay_new ();
#line 84 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp12_);
#line 84 "../src/DeviceRow.vala"
	overlay = _tmp12_;
#line 85 "../src/DeviceRow.vala"
	_tmp13_ = overlay;
#line 85 "../src/DeviceRow.vala"
	_tmp14_ = self->priv->_device;
#line 85 "../src/DeviceRow.vala"
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
#line 85 "../src/DeviceRow.vala"
	_tmp16_ = _tmp15_;
#line 85 "../src/DeviceRow.vala"
	_tmp17_ = _tmp16_;
#line 85 "../src/DeviceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp17_);
#line 85 "../src/DeviceRow.vala"
	_g_free0 (_tmp17_);
#line 86 "../src/DeviceRow.vala"
	_tmp18_ = overlay;
#line 86 "../src/DeviceRow.vala"
	_tmp19_ = _data1_->image;
#line 86 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 87 "../src/DeviceRow.vala"
	_tmp20_ = overlay;
#line 87 "../src/DeviceRow.vala"
	_tmp21_ = self->priv->state;
#line 87 "../src/DeviceRow.vala"
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
#line 89 "../src/DeviceRow.vala"
	_tmp22_ = self->priv->_device;
#line 89 "../src/DeviceRow.vala"
	_tmp23_ = bluetooth_services_device_get_name (_tmp22_);
#line 89 "../src/DeviceRow.vala"
	_tmp24_ = _tmp23_;
#line 89 "../src/DeviceRow.vala"
	device_name = _tmp24_;
#line 90 "../src/DeviceRow.vala"
	_tmp25_ = device_name;
#line 90 "../src/DeviceRow.vala"
	if (_tmp25_ == NULL) {
#line 1693 "DeviceRow.c"
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gboolean _tmp30_;
#line 91 "../src/DeviceRow.vala"
		_tmp26_ = self->priv->_device;
#line 91 "../src/DeviceRow.vala"
		_tmp27_ = bluetooth_services_device_get_icon (_tmp26_);
#line 91 "../src/DeviceRow.vala"
		_tmp28_ = _tmp27_;
#line 91 "../src/DeviceRow.vala"
		_tmp29_ = _tmp28_;
#line 91 "../src/DeviceRow.vala"
		_tmp30_ = _tmp29_ != NULL;
#line 91 "../src/DeviceRow.vala"
		_g_free0 (_tmp29_);
#line 91 "../src/DeviceRow.vala"
		if (_tmp30_) {
#line 1713 "DeviceRow.c"
			BluetoothServicesDevice* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GQuark _tmp36_ = 0U;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label0 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label1 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label2 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label3 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label4 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label5 = 0;
#line 92 "../src/DeviceRow.vala"
			static GQuark _tmp35_label6 = 0;
#line 92 "../src/DeviceRow.vala"
			_tmp31_ = self->priv->_device;
#line 92 "../src/DeviceRow.vala"
			_tmp32_ = bluetooth_services_device_get_icon (_tmp31_);
#line 92 "../src/DeviceRow.vala"
			_tmp33_ = _tmp32_;
#line 92 "../src/DeviceRow.vala"
			_tmp34_ = _tmp33_;
#line 92 "../src/DeviceRow.vala"
			_tmp36_ = (NULL == _tmp34_) ? 0 : g_quark_from_string (_tmp34_);
#line 92 "../src/DeviceRow.vala"
			g_free (_tmp34_);
#line 92 "../src/DeviceRow.vala"
			if (_tmp36_ == ((0 != _tmp35_label0) ? _tmp35_label0 : (_tmp35_label0 = g_quark_from_static_string ("audio-card")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1749 "DeviceRow.c"
					default:
					{
						gchar* _tmp37_;
#line 94 "../src/DeviceRow.vala"
						_tmp37_ = g_strdup (_ ("Speaker"));
#line 94 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 94 "../src/DeviceRow.vala"
						device_name = _tmp37_;
#line 95 "../src/DeviceRow.vala"
						break;
#line 1761 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label1) ? _tmp35_label1 : (_tmp35_label1 = g_quark_from_static_string ("input-gaming")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1767 "DeviceRow.c"
					default:
					{
						gchar* _tmp38_;
#line 97 "../src/DeviceRow.vala"
						_tmp38_ = g_strdup (_ ("Controller"));
#line 97 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 97 "../src/DeviceRow.vala"
						device_name = _tmp38_;
#line 98 "../src/DeviceRow.vala"
						break;
#line 1779 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label2) ? _tmp35_label2 : (_tmp35_label2 = g_quark_from_static_string ("input-keyboard")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1785 "DeviceRow.c"
					default:
					{
						gchar* _tmp39_;
#line 100 "../src/DeviceRow.vala"
						_tmp39_ = g_strdup (_ ("Keyboard"));
#line 100 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 100 "../src/DeviceRow.vala"
						device_name = _tmp39_;
#line 101 "../src/DeviceRow.vala"
						break;
#line 1797 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label3) ? _tmp35_label3 : (_tmp35_label3 = g_quark_from_static_string ("input-mouse")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1803 "DeviceRow.c"
					default:
					{
						gchar* _tmp40_;
#line 103 "../src/DeviceRow.vala"
						_tmp40_ = g_strdup (_ ("Mouse"));
#line 103 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 103 "../src/DeviceRow.vala"
						device_name = _tmp40_;
#line 104 "../src/DeviceRow.vala"
						break;
#line 1815 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label4) ? _tmp35_label4 : (_tmp35_label4 = g_quark_from_static_string ("input-tablet")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1821 "DeviceRow.c"
					default:
					{
						gchar* _tmp41_;
#line 106 "../src/DeviceRow.vala"
						_tmp41_ = g_strdup (_ ("Tablet"));
#line 106 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 106 "../src/DeviceRow.vala"
						device_name = _tmp41_;
#line 107 "../src/DeviceRow.vala"
						break;
#line 1833 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label5) ? _tmp35_label5 : (_tmp35_label5 = g_quark_from_static_string ("input-touchpad")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1839 "DeviceRow.c"
					default:
					{
						gchar* _tmp42_;
#line 109 "../src/DeviceRow.vala"
						_tmp42_ = g_strdup (_ ("Touchpad"));
#line 109 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 109 "../src/DeviceRow.vala"
						device_name = _tmp42_;
#line 110 "../src/DeviceRow.vala"
						break;
#line 1851 "DeviceRow.c"
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label6) ? _tmp35_label6 : (_tmp35_label6 = g_quark_from_static_string ("phone")))) {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1857 "DeviceRow.c"
					default:
					{
						gchar* _tmp43_;
#line 112 "../src/DeviceRow.vala"
						_tmp43_ = g_strdup (_ ("Phone"));
#line 112 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 112 "../src/DeviceRow.vala"
						device_name = _tmp43_;
#line 113 "../src/DeviceRow.vala"
						break;
#line 1869 "DeviceRow.c"
					}
				}
			} else {
#line 92 "../src/DeviceRow.vala"
				switch (0) {
#line 1875 "DeviceRow.c"
					default:
					{
						BluetoothServicesDevice* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
#line 115 "../src/DeviceRow.vala"
						_tmp44_ = self->priv->_device;
#line 115 "../src/DeviceRow.vala"
						_tmp45_ = bluetooth_services_device_get_address (_tmp44_);
#line 115 "../src/DeviceRow.vala"
						_tmp46_ = _tmp45_;
#line 115 "../src/DeviceRow.vala"
						_g_free0 (device_name);
#line 115 "../src/DeviceRow.vala"
						device_name = _tmp46_;
#line 1891 "DeviceRow.c"
					}
				}
			}
		} else {
			BluetoothServicesDevice* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 118 "../src/DeviceRow.vala"
			_tmp47_ = self->priv->_device;
#line 118 "../src/DeviceRow.vala"
			_tmp48_ = bluetooth_services_device_get_address (_tmp47_);
#line 118 "../src/DeviceRow.vala"
			_tmp49_ = _tmp48_;
#line 118 "../src/DeviceRow.vala"
			_g_free0 (device_name);
#line 118 "../src/DeviceRow.vala"
			device_name = _tmp49_;
#line 1909 "DeviceRow.c"
		}
	}
#line 122 "../src/DeviceRow.vala"
	_tmp50_ = device_name;
#line 122 "../src/DeviceRow.vala"
	_tmp51_ = (GtkLabel*) gtk_label_new (_tmp50_);
#line 122 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp51_);
#line 122 "../src/DeviceRow.vala"
	_data1_->label = _tmp51_;
#line 123 "../src/DeviceRow.vala"
	_tmp52_ = _data1_->label;
#line 123 "../src/DeviceRow.vala"
	gtk_label_set_ellipsize (_tmp52_, PANGO_ELLIPSIZE_END);
#line 124 "../src/DeviceRow.vala"
	_tmp53_ = _data1_->label;
#line 124 "../src/DeviceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
#line 125 "../src/DeviceRow.vala"
	_tmp54_ = _data1_->label;
#line 125 "../src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp54_, (gfloat) 0);
#line 127 "../src/DeviceRow.vala"
	_tmp55_ = (GtkLinkButton*) gtk_link_button_new ("");
#line 127 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp55_);
#line 127 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 127 "../src/DeviceRow.vala"
	self->priv->settings_button = _tmp55_;
#line 128 "../src/DeviceRow.vala"
	_tmp56_ = self->priv->settings_button;
#line 128 "../src/DeviceRow.vala"
	gtk_button_set_always_show_image ((GtkButton*) _tmp56_, TRUE);
#line 129 "../src/DeviceRow.vala"
	_tmp57_ = self->priv->settings_button;
#line 129 "../src/DeviceRow.vala"
	_tmp58_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 129 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp58_);
#line 129 "../src/DeviceRow.vala"
	_tmp59_ = _tmp58_;
#line 129 "../src/DeviceRow.vala"
	gtk_button_set_image ((GtkButton*) _tmp57_, (GtkWidget*) _tmp59_);
#line 129 "../src/DeviceRow.vala"
	_g_object_unref0 (_tmp59_);
#line 130 "../src/DeviceRow.vala"
	_tmp60_ = self->priv->settings_button;
#line 130 "../src/DeviceRow.vala"
	gtk_button_set_label ((GtkButton*) _tmp60_, NULL);
#line 131 "../src/DeviceRow.vala"
	_tmp61_ = self->priv->settings_button;
#line 131 "../src/DeviceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp61_, 3);
#line 132 "../src/DeviceRow.vala"
	_tmp62_ = self->priv->settings_button;
#line 132 "../src/DeviceRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp62_);
#line 133 "../src/DeviceRow.vala"
	_tmp63_ = self->priv->settings_button;
#line 133 "../src/DeviceRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp63_, TRUE);
#line 134 "../src/DeviceRow.vala"
	_tmp64_ = self->priv->settings_button;
#line 134 "../src/DeviceRow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp64_, FALSE);
#line 136 "../src/DeviceRow.vala"
	_tmp65_ = g_strdup (_ ("Forget this device"));
#line 136 "../src/DeviceRow.vala"
	_tmp66_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 136 "../src/DeviceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp66_, 3);
#line 136 "../src/DeviceRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp66_, TRUE);
#line 136 "../src/DeviceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp66_, _tmp65_);
#line 136 "../src/DeviceRow.vala"
	_g_free0 (_tmp65_);
#line 136 "../src/DeviceRow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp66_, FALSE);
#line 136 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp66_);
#line 136 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->forget_button);
#line 136 "../src/DeviceRow.vala"
	self->priv->forget_button = _tmp66_;
#line 142 "../src/DeviceRow.vala"
	_tmp67_ = self->priv->forget_button;
#line 142 "../src/DeviceRow.vala"
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
#line 142 "../src/DeviceRow.vala"
	gtk_style_context_add_class (_tmp68_, GTK_STYLE_CLASS_FLAT);
#line 144 "../src/DeviceRow.vala"
	_tmp69_ = (GtkButton*) gtk_button_new ();
#line 144 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp69_);
#line 144 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 144 "../src/DeviceRow.vala"
	self->priv->connect_button = _tmp69_;
#line 145 "../src/DeviceRow.vala"
	_tmp70_ = self->priv->connect_button;
#line 145 "../src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp70_, GTK_ALIGN_CENTER);
#line 147 "../src/DeviceRow.vala"
	_tmp71_ = bluetooth_device_row_size_group;
#line 147 "../src/DeviceRow.vala"
	_tmp72_ = self->priv->connect_button;
#line 147 "../src/DeviceRow.vala"
	gtk_size_group_add_widget (_tmp71_, (GtkWidget*) _tmp72_);
#line 149 "../src/DeviceRow.vala"
	_tmp73_ = (GtkGrid*) gtk_grid_new ();
#line 149 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp73_);
#line 149 "../src/DeviceRow.vala"
	grid = _tmp73_;
#line 150 "../src/DeviceRow.vala"
	_tmp74_ = grid;
#line 150 "../src/DeviceRow.vala"
	g_object_set ((GtkWidget*) _tmp74_, "margin", 6, NULL);
#line 151 "../src/DeviceRow.vala"
	_tmp75_ = grid;
#line 151 "../src/DeviceRow.vala"
	gtk_grid_set_column_spacing (_tmp75_, 6);
#line 152 "../src/DeviceRow.vala"
	_tmp76_ = grid;
#line 152 "../src/DeviceRow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp76_, GTK_ORIENTATION_HORIZONTAL);
#line 153 "../src/DeviceRow.vala"
	_tmp77_ = grid;
#line 153 "../src/DeviceRow.vala"
	_tmp78_ = overlay;
#line 153 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 0, 1, 2);
#line 154 "../src/DeviceRow.vala"
	_tmp79_ = grid;
#line 154 "../src/DeviceRow.vala"
	_tmp80_ = _data1_->label;
#line 154 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 0, 1, 1);
#line 155 "../src/DeviceRow.vala"
	_tmp81_ = grid;
#line 155 "../src/DeviceRow.vala"
	_tmp82_ = self->priv->state_label;
#line 155 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 1, 1, 1, 1);
#line 156 "../src/DeviceRow.vala"
	_tmp83_ = grid;
#line 156 "../src/DeviceRow.vala"
	_tmp84_ = self->priv->settings_button;
#line 156 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 2, 0, 1, 2);
#line 157 "../src/DeviceRow.vala"
	_tmp85_ = grid;
#line 157 "../src/DeviceRow.vala"
	_tmp86_ = self->priv->forget_button;
#line 157 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp85_, (GtkWidget*) _tmp86_, 3, 0, 1, 2);
#line 158 "../src/DeviceRow.vala"
	_tmp87_ = grid;
#line 158 "../src/DeviceRow.vala"
	_tmp88_ = self->priv->connect_button;
#line 158 "../src/DeviceRow.vala"
	gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, 4, 0, 1, 2);
#line 160 "../src/DeviceRow.vala"
	_tmp89_ = grid;
#line 160 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp89_);
#line 161 "../src/DeviceRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 163 "../src/DeviceRow.vala"
	_tmp90_ = self->priv->_device;
#line 163 "../src/DeviceRow.vala"
	_tmp91_ = bluetooth_services_device_get_icon (_tmp90_);
#line 163 "../src/DeviceRow.vala"
	_tmp92_ = _tmp91_;
#line 163 "../src/DeviceRow.vala"
	_tmp93_ = _tmp92_;
#line 163 "../src/DeviceRow.vala"
	_tmp95_ = (NULL == _tmp93_) ? 0 : g_quark_from_string (_tmp93_);
#line 163 "../src/DeviceRow.vala"
	g_free (_tmp93_);
#line 163 "../src/DeviceRow.vala"
	if (_tmp95_ == ((0 != _tmp94_label0) ? _tmp94_label0 : (_tmp94_label0 = g_quark_from_static_string ("audio-card")))) {
#line 163 "../src/DeviceRow.vala"
		switch (0) {
#line 2096 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp96_;
				GtkLinkButton* _tmp97_;
#line 165 "../src/DeviceRow.vala"
				_tmp96_ = self->priv->settings_button;
#line 165 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp96_, "settings://sound");
#line 166 "../src/DeviceRow.vala"
				_tmp97_ = self->priv->settings_button;
#line 166 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp97_, _ ("Sound Settings"));
#line 167 "../src/DeviceRow.vala"
				break;
#line 2111 "DeviceRow.c"
			}
		}
	} else if ((_tmp95_ == ((0 != _tmp94_label1) ? _tmp94_label1 : (_tmp94_label1 = g_quark_from_static_string ("input-gaming")))) || (_tmp95_ == ((0 != _tmp94_label2) ? _tmp94_label2 : (_tmp94_label2 = g_quark_from_static_string ("input-keyboard"))))) {
#line 163 "../src/DeviceRow.vala"
		switch (0) {
#line 2117 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp98_;
				GtkLinkButton* _tmp99_;
#line 170 "../src/DeviceRow.vala"
				_tmp98_ = self->priv->settings_button;
#line 170 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp98_, "settings://input/keyboard");
#line 171 "../src/DeviceRow.vala"
				_tmp99_ = self->priv->settings_button;
#line 171 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp99_, _ ("Keyboard Settings"));
#line 172 "../src/DeviceRow.vala"
				break;
#line 2132 "DeviceRow.c"
			}
		}
	} else if (_tmp95_ == ((0 != _tmp94_label3) ? _tmp94_label3 : (_tmp94_label3 = g_quark_from_static_string ("input-mouse")))) {
#line 163 "../src/DeviceRow.vala"
		switch (0) {
#line 2138 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp100_;
				GtkLinkButton* _tmp101_;
#line 174 "../src/DeviceRow.vala"
				_tmp100_ = self->priv->settings_button;
#line 174 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp100_, "settings://input/mouse");
#line 175 "../src/DeviceRow.vala"
				_tmp101_ = self->priv->settings_button;
#line 175 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp101_, _ ("Mouse & Touchpad Settings"));
#line 176 "../src/DeviceRow.vala"
				break;
#line 2153 "DeviceRow.c"
			}
		}
	} else if (_tmp95_ == ((0 != _tmp94_label4) ? _tmp94_label4 : (_tmp94_label4 = g_quark_from_static_string ("printer")))) {
#line 163 "../src/DeviceRow.vala"
		switch (0) {
#line 2159 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp102_;
				GtkLinkButton* _tmp103_;
#line 178 "../src/DeviceRow.vala"
				_tmp102_ = self->priv->settings_button;
#line 178 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp102_, "settings://printer");
#line 179 "../src/DeviceRow.vala"
				_tmp103_ = self->priv->settings_button;
#line 179 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp103_, _ ("Printer Settings"));
#line 180 "../src/DeviceRow.vala"
				break;
#line 2174 "DeviceRow.c"
			}
		}
	} else {
#line 163 "../src/DeviceRow.vala"
		switch (0) {
#line 2180 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp104_;
				GtkLinkButton* _tmp105_;
#line 182 "../src/DeviceRow.vala"
				_tmp104_ = self->priv->settings_button;
#line 182 "../src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp104_, NULL);
#line 183 "../src/DeviceRow.vala"
				_tmp105_ = self->priv->settings_button;
#line 183 "../src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp105_, NULL);
#line 184 "../src/DeviceRow.vala"
				break;
#line 2195 "DeviceRow.c"
			}
		}
	}
#line 187 "../src/DeviceRow.vala"
	bluetooth_device_row_compute_status (self);
#line 188 "../src/DeviceRow.vala"
	_tmp106_ = self->priv->_adapter;
#line 188 "../src/DeviceRow.vala"
	_tmp107_ = bluetooth_services_adapter_get_powered (_tmp106_);
#line 188 "../src/DeviceRow.vala"
	_tmp108_ = _tmp107_;
#line 188 "../src/DeviceRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp108_);
#line 190 "../src/DeviceRow.vala"
	_tmp109_ = self->priv->_adapter;
#line 190 "../src/DeviceRow.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed, self, 0);
#line 198 "../src/DeviceRow.vala"
	_tmp110_ = self->priv->_device;
#line 198 "../src/DeviceRow.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 223 "../src/DeviceRow.vala"
	_tmp111_ = self->priv->connect_button;
#line 223 "../src/DeviceRow.vala"
	g_signal_connect_object (_tmp111_, "clicked", (GCallback) __bluetooth_device_row___lambda25__gtk_button_clicked, self, 0);
#line 229 "../src/DeviceRow.vala"
	_tmp112_ = self->priv->forget_button;
#line 229 "../src/DeviceRow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp112_, "button-release-event", (GCallback) __bluetooth_device_row___lambda26__gtk_widget_button_release_event, self, 0);
#line 73 "../src/DeviceRow.vala"
	_g_object_unref0 (grid);
#line 73 "../src/DeviceRow.vala"
	_g_free0 (device_name);
#line 73 "../src/DeviceRow.vala"
	_g_object_unref0 (overlay);
#line 73 "../src/DeviceRow.vala"
	_g_free0 (_tmp0_);
#line 73 "../src/DeviceRow.vala"
	block1_data_unref (_data1_);
#line 73 "../src/DeviceRow.vala"
	_data1_ = NULL;
#line 73 "../src/DeviceRow.vala"
	return obj;
#line 2239 "DeviceRow.c"
}

static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass,
                                 gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
#line 21 "../src/DeviceRow.vala"
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/DeviceRow.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
#line 21 "../src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/DeviceRow.vala"
	bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL] = g_signal_new ("status-changed", BLUETOOTH_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 70 "../src/DeviceRow.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 70 "../src/DeviceRow.vala"
	_g_object_unref0 (bluetooth_device_row_size_group);
#line 70 "../src/DeviceRow.vala"
	bluetooth_device_row_size_group = _tmp0_;
#line 2271 "DeviceRow.c"
}

static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self,
                                    gpointer klass)
{
#line 21 "../src/DeviceRow.vala"
	self->priv = bluetooth_device_row_get_instance_private (self);
#line 2280 "DeviceRow.c"
}

static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
#line 21 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 22 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->_device);
#line 59 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 60 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->forget_button);
#line 61 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 62 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 63 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 21 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
#line 2303 "DeviceRow.c"
}

static GType
bluetooth_device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
	GType bluetooth_device_row_type_id;
	bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
	BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
	return bluetooth_device_row_type_id;
}

GType
bluetooth_device_row_get_type (void)
{
	static volatile gsize bluetooth_device_row_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__once)) {
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = bluetooth_device_row_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_type_id__once, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__once;
}

static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "../src/DeviceRow.vala"
	switch (property_id) {
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_device (self));
#line 21 "../src/DeviceRow.vala"
		break;
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
#line 21 "../src/DeviceRow.vala"
		break;
#line 2350 "DeviceRow.c"
		default:
#line 21 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/DeviceRow.vala"
		break;
#line 2356 "DeviceRow.c"
	}
}

static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "../src/DeviceRow.vala"
	switch (property_id) {
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		bluetooth_device_row_set_device (self, g_value_get_object (value));
#line 21 "../src/DeviceRow.vala"
		break;
#line 21 "../src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
#line 21 "../src/DeviceRow.vala"
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
#line 21 "../src/DeviceRow.vala"
		break;
#line 2382 "DeviceRow.c"
		default:
#line 21 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/DeviceRow.vala"
		break;
#line 2388 "DeviceRow.c"
	}
}

