/* MainView.c generated by valac 0.56.13, the Vala compiler
 * generated from MainView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Oleksandr Lynok <oleksandr.lynok@gmail.com>
 */

#include "bluetooth.h"
#include <gtk/gtk.h>
#include <granite.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

enum  {
	BLUETOOTH_MAIN_VIEW_0_PROPERTY,
	BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY,
	BLUETOOTH_MAIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BLUETOOTH_MAIN_VIEW_QUIT_PLUG_SIGNAL,
	BLUETOOTH_MAIN_VIEW_NUM_SIGNALS
};
static guint bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_NUM_SIGNALS] = {0};

struct _BluetoothMainViewPrivate {
	GtkListBox* list_box;
	GraniteWidgetsOverlayBar* overlaybar;
	BluetoothServicesObjectManager* _manager;
};

static gint BluetoothMainView_private_offset;
static gpointer bluetooth_main_view_parent_class = NULL;

static void bluetooth_main_view_complete_setup (BluetoothMainView* self);
static void bluetooth_main_view_update_description (BluetoothMainView* self);
static void __lambda27_ (BluetoothMainView* self,
                  BluetoothServicesDevice* device);
static void ___lambda27__bluetooth_services_object_manager_device_added (BluetoothServicesObjectManager* _sender,
                                                                  BluetoothServicesDevice* device,
                                                                  gpointer self);
static void __lambda28_ (BluetoothMainView* self,
                  BluetoothServicesDevice* device);
static void ___lambda28__bluetooth_services_object_manager_device_removed (BluetoothServicesObjectManager* _sender,
                                                                    BluetoothServicesDevice* device,
                                                                    gpointer self);
static void __lambda29_ (BluetoothMainView* self,
                  BluetoothServicesAdapter* adapter);
static void ___lambda29__bluetooth_services_object_manager_adapter_added (BluetoothServicesObjectManager* _sender,
                                                                   BluetoothServicesAdapter* adapter,
                                                                   gpointer self);
static void __lambda30_ (BluetoothMainView* self,
                  BluetoothServicesAdapter* adapter);
static void ___lambda30__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                     BluetoothServicesAdapter* adapter,
                                                                     gpointer self);
static void __lambda31_ (BluetoothMainView* self);
static void ___lambda31__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda32_ (BluetoothMainView* self);
static void ___lambda32__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gint bluetooth_main_view_compare_rows (BluetoothDeviceRow* row1,
                                       BluetoothDeviceRow* row2,
                                       BluetoothMainView* self);
static void bluetooth_main_view_title_rows (BluetoothDeviceRow* row1,
                                     BluetoothDeviceRow* row2,
                                     BluetoothMainView* self);
static GObject * bluetooth_main_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _bluetooth_main_view_complete_setup_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _bluetooth_main_view___lambda33_ (BluetoothMainView* self);
static void __bluetooth_main_view___lambda33__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void bluetooth_main_view_finalize (GObject * obj);
static GType bluetooth_main_view_get_type_once (void);
static void _vala_bluetooth_main_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_bluetooth_main_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
bluetooth_main_view_get_instance_private (BluetoothMainView* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothMainView_private_offset);
}

BluetoothMainView*
bluetooth_main_view_construct (GType object_type,
                               BluetoothServicesObjectManager* manager)
{
	BluetoothMainView * self = NULL;
#line 30 "../src/MainView.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 31 "../src/MainView.vala"
	self = (BluetoothMainView*) g_object_new (object_type, "icon-name", "bluetooth", "manager", manager, "title", _ ("Bluetooth"), "activatable", TRUE, "description", "", NULL);
#line 30 "../src/MainView.vala"
	return self;
#line 135 "MainView.c"
}

BluetoothMainView*
bluetooth_main_view_new (BluetoothServicesObjectManager* manager)
{
#line 30 "../src/MainView.vala"
	return bluetooth_main_view_construct (BLUETOOTH_TYPE_MAIN_VIEW, manager);
#line 143 "MainView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 96 "../src/MainView.vala"
	return self ? g_object_ref (self) : NULL;
#line 151 "MainView.c"
}

static void
__lambda27_ (BluetoothMainView* self,
             BluetoothServicesDevice* device)
{
	BluetoothServicesAdapter* adapter = NULL;
	BluetoothServicesObjectManager* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	BluetoothServicesAdapter* _tmp4_;
	BluetoothServicesAdapter* _tmp5_;
	BluetoothDeviceRow* row = NULL;
	BluetoothServicesAdapter* _tmp6_;
	BluetoothDeviceRow* _tmp7_;
	GtkListBox* _tmp8_;
	BluetoothDeviceRow* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBoxRow* _tmp11_;
#line 107 "../src/MainView.vala"
	g_return_if_fail (device != NULL);
#line 108 "../src/MainView.vala"
	_tmp0_ = self->priv->_manager;
#line 108 "../src/MainView.vala"
	_tmp1_ = bluetooth_services_device_get_adapter (device);
#line 108 "../src/MainView.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/MainView.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/MainView.vala"
	_tmp4_ = bluetooth_services_object_manager_get_adapter_from_path (_tmp0_, (const gchar*) _tmp3_);
#line 108 "../src/MainView.vala"
	_tmp5_ = _tmp4_;
#line 108 "../src/MainView.vala"
	_g_free0 (_tmp3_);
#line 108 "../src/MainView.vala"
	adapter = _tmp5_;
#line 109 "../src/MainView.vala"
	_tmp6_ = adapter;
#line 109 "../src/MainView.vala"
	_tmp7_ = bluetooth_device_row_new (device, _tmp6_);
#line 109 "../src/MainView.vala"
	g_object_ref_sink (_tmp7_);
#line 109 "../src/MainView.vala"
	row = _tmp7_;
#line 110 "../src/MainView.vala"
	_tmp8_ = self->priv->list_box;
#line 110 "../src/MainView.vala"
	_tmp9_ = row;
#line 110 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 111 "../src/MainView.vala"
	_tmp10_ = self->priv->list_box;
#line 111 "../src/MainView.vala"
	_tmp11_ = gtk_list_box_get_selected_row (_tmp10_);
#line 111 "../src/MainView.vala"
	if (_tmp11_ == NULL) {
#line 210 "MainView.c"
		GtkListBox* _tmp12_;
		BluetoothDeviceRow* _tmp13_;
		GtkListBox* _tmp14_;
		BluetoothDeviceRow* _tmp15_;
#line 112 "../src/MainView.vala"
		_tmp12_ = self->priv->list_box;
#line 112 "../src/MainView.vala"
		_tmp13_ = row;
#line 112 "../src/MainView.vala"
		gtk_list_box_select_row (_tmp12_, (GtkListBoxRow*) _tmp13_);
#line 113 "../src/MainView.vala"
		_tmp14_ = self->priv->list_box;
#line 113 "../src/MainView.vala"
		_tmp15_ = row;
#line 113 "../src/MainView.vala"
		g_signal_emit_by_name (_tmp14_, "row-activated", (GtkListBoxRow*) _tmp15_);
#line 227 "MainView.c"
	}
#line 107 "../src/MainView.vala"
	_g_object_unref0 (row);
#line 107 "../src/MainView.vala"
	_g_object_unref0 (adapter);
#line 233 "MainView.c"
}

static void
___lambda27__bluetooth_services_object_manager_device_added (BluetoothServicesObjectManager* _sender,
                                                             BluetoothServicesDevice* device,
                                                             gpointer self)
{
#line 107 "../src/MainView.vala"
	__lambda27_ ((BluetoothMainView*) self, device);
#line 243 "MainView.c"
}

static void
__lambda28_ (BluetoothMainView* self,
             BluetoothServicesDevice* device)
{
	GtkListBox* _tmp0_;
	GList* _tmp1_;
#line 117 "../src/MainView.vala"
	g_return_if_fail (device != NULL);
#line 118 "../src/MainView.vala"
	_tmp0_ = self->priv->list_box;
#line 118 "../src/MainView.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 258 "MainView.c"
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
#line 118 "../src/MainView.vala"
		row_collection = _tmp1_;
#line 118 "../src/MainView.vala"
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
#line 266 "MainView.c"
			GtkWidget* row = NULL;
#line 118 "../src/MainView.vala"
			row = (GtkWidget*) row_it->data;
#line 270 "MainView.c"
			{
				GtkWidget* _tmp2_;
				BluetoothServicesDevice* _tmp3_;
				BluetoothServicesDevice* _tmp4_;
#line 119 "../src/MainView.vala"
				_tmp2_ = row;
#line 119 "../src/MainView.vala"
				_tmp3_ = bluetooth_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow));
#line 119 "../src/MainView.vala"
				_tmp4_ = _tmp3_;
#line 119 "../src/MainView.vala"
				if (_tmp4_ == device) {
#line 283 "MainView.c"
					GtkListBox* _tmp5_;
					GtkWidget* _tmp6_;
#line 120 "../src/MainView.vala"
					_tmp5_ = self->priv->list_box;
#line 120 "../src/MainView.vala"
					_tmp6_ = row;
#line 120 "../src/MainView.vala"
					gtk_container_remove ((GtkContainer*) _tmp5_, _tmp6_);
#line 121 "../src/MainView.vala"
					break;
#line 294 "MainView.c"
				}
			}
		}
#line 118 "../src/MainView.vala"
		(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
#line 300 "MainView.c"
	}
}

static void
___lambda28__bluetooth_services_object_manager_device_removed (BluetoothServicesObjectManager* _sender,
                                                               BluetoothServicesDevice* device,
                                                               gpointer self)
{
#line 117 "../src/MainView.vala"
	__lambda28_ ((BluetoothMainView*) self, device);
#line 311 "MainView.c"
}

static void
__lambda29_ (BluetoothMainView* self,
             BluetoothServicesAdapter* adapter)
{
#line 126 "../src/MainView.vala"
	g_return_if_fail (adapter != NULL);
#line 127 "../src/MainView.vala"
	bluetooth_main_view_update_description (self);
#line 322 "MainView.c"
}

static void
___lambda29__bluetooth_services_object_manager_adapter_added (BluetoothServicesObjectManager* _sender,
                                                              BluetoothServicesAdapter* adapter,
                                                              gpointer self)
{
#line 126 "../src/MainView.vala"
	__lambda29_ ((BluetoothMainView*) self, adapter);
#line 332 "MainView.c"
}

static void
__lambda30_ (BluetoothMainView* self,
             BluetoothServicesAdapter* adapter)
{
	BluetoothServicesObjectManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 130 "../src/MainView.vala"
	g_return_if_fail (adapter != NULL);
#line 131 "../src/MainView.vala"
	_tmp0_ = self->priv->_manager;
#line 131 "../src/MainView.vala"
	_tmp1_ = bluetooth_services_object_manager_get_has_object (_tmp0_);
#line 131 "../src/MainView.vala"
	_tmp2_ = _tmp1_;
#line 131 "../src/MainView.vala"
	if (!_tmp2_) {
#line 132 "../src/MainView.vala"
		g_signal_emit (self, bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_QUIT_PLUG_SIGNAL], 0);
#line 354 "MainView.c"
	} else {
#line 134 "../src/MainView.vala"
		bluetooth_main_view_update_description (self);
#line 358 "MainView.c"
	}
}

static void
___lambda30__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                BluetoothServicesAdapter* adapter,
                                                                gpointer self)
{
#line 130 "../src/MainView.vala"
	__lambda30_ ((BluetoothMainView*) self, adapter);
#line 369 "MainView.c"
}

static void
__lambda31_ (BluetoothMainView* self)
{
#line 139 "../src/MainView.vala"
	bluetooth_main_view_update_description (self);
#line 377 "MainView.c"
}

static void
___lambda31__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 138 "../src/MainView.vala"
	__lambda31_ ((BluetoothMainView*) self);
#line 387 "MainView.c"
}

static void
__lambda32_ (BluetoothMainView* self)
{
#line 143 "../src/MainView.vala"
	bluetooth_main_view_update_description (self);
#line 395 "MainView.c"
}

static void
___lambda32__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 142 "../src/MainView.vala"
	__lambda32_ ((BluetoothMainView*) self);
#line 405 "MainView.c"
}

static void
bluetooth_main_view_complete_setup (BluetoothMainView* self)
{
	GtkListBoxRow* first_row = NULL;
	GtkListBox* _tmp20_;
	GtkListBoxRow* _tmp21_;
	GtkListBoxRow* _tmp22_;
	GtkListBoxRow* _tmp23_;
	GtkSwitch* _tmp28_;
	GtkSwitch* _tmp29_;
	BluetoothServicesObjectManager* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	BluetoothServicesObjectManager* _tmp33_;
	BluetoothServicesObjectManager* _tmp34_;
	BluetoothServicesObjectManager* _tmp35_;
	BluetoothServicesObjectManager* _tmp36_;
	BluetoothServicesObjectManager* _tmp37_;
	BluetoothServicesObjectManager* _tmp38_;
	BluetoothServicesObjectManager* _tmp39_;
	GraniteWidgetsOverlayBar* _tmp40_;
	BluetoothServicesObjectManager* _tmp41_;
	GtkSwitch* _tmp42_;
	GtkSwitch* _tmp43_;
#line 89 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 434 "MainView.c"
	{
		GeeIterator* _device_it = NULL;
		BluetoothServicesObjectManager* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 90 "../src/MainView.vala"
		_tmp0_ = self->priv->_manager;
#line 90 "../src/MainView.vala"
		_tmp1_ = bluetooth_services_object_manager_get_devices (_tmp0_);
#line 90 "../src/MainView.vala"
		_tmp2_ = _tmp1_;
#line 90 "../src/MainView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 90 "../src/MainView.vala"
		_tmp4_ = _tmp3_;
#line 90 "../src/MainView.vala"
		_g_object_unref0 (_tmp2_);
#line 90 "../src/MainView.vala"
		_device_it = _tmp4_;
#line 90 "../src/MainView.vala"
		while (TRUE) {
#line 458 "MainView.c"
			GeeIterator* _tmp5_;
			BluetoothServicesDevice* device = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			BluetoothServicesAdapter* adapter = NULL;
			BluetoothServicesObjectManager* _tmp8_;
			BluetoothServicesDevice* _tmp9_;
			char* _tmp10_;
			char* _tmp11_;
			char* _tmp12_;
			BluetoothServicesAdapter* _tmp13_;
			BluetoothServicesAdapter* _tmp14_;
			BluetoothDeviceRow* row = NULL;
			BluetoothServicesDevice* _tmp15_;
			BluetoothServicesAdapter* _tmp16_;
			BluetoothDeviceRow* _tmp17_;
			GtkListBox* _tmp18_;
			BluetoothDeviceRow* _tmp19_;
#line 90 "../src/MainView.vala"
			_tmp5_ = _device_it;
#line 90 "../src/MainView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 90 "../src/MainView.vala"
				break;
#line 483 "MainView.c"
			}
#line 90 "../src/MainView.vala"
			_tmp6_ = _device_it;
#line 90 "../src/MainView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 90 "../src/MainView.vala"
			device = (BluetoothServicesDevice*) _tmp7_;
#line 91 "../src/MainView.vala"
			_tmp8_ = self->priv->_manager;
#line 91 "../src/MainView.vala"
			_tmp9_ = device;
#line 91 "../src/MainView.vala"
			_tmp10_ = bluetooth_services_device_get_adapter (_tmp9_);
#line 91 "../src/MainView.vala"
			_tmp11_ = _tmp10_;
#line 91 "../src/MainView.vala"
			_tmp12_ = _tmp11_;
#line 91 "../src/MainView.vala"
			_tmp13_ = bluetooth_services_object_manager_get_adapter_from_path (_tmp8_, (const gchar*) _tmp12_);
#line 91 "../src/MainView.vala"
			_tmp14_ = _tmp13_;
#line 91 "../src/MainView.vala"
			_g_free0 (_tmp12_);
#line 91 "../src/MainView.vala"
			adapter = _tmp14_;
#line 92 "../src/MainView.vala"
			_tmp15_ = device;
#line 92 "../src/MainView.vala"
			_tmp16_ = adapter;
#line 92 "../src/MainView.vala"
			_tmp17_ = bluetooth_device_row_new (_tmp15_, _tmp16_);
#line 92 "../src/MainView.vala"
			g_object_ref_sink (_tmp17_);
#line 92 "../src/MainView.vala"
			row = _tmp17_;
#line 93 "../src/MainView.vala"
			_tmp18_ = self->priv->list_box;
#line 93 "../src/MainView.vala"
			_tmp19_ = row;
#line 93 "../src/MainView.vala"
			gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 90 "../src/MainView.vala"
			_g_object_unref0 (row);
#line 90 "../src/MainView.vala"
			_g_object_unref0 (adapter);
#line 90 "../src/MainView.vala"
			_g_object_unref0 (device);
#line 531 "MainView.c"
		}
#line 90 "../src/MainView.vala"
		_g_object_unref0 (_device_it);
#line 535 "MainView.c"
	}
#line 96 "../src/MainView.vala"
	_tmp20_ = self->priv->list_box;
#line 96 "../src/MainView.vala"
	_tmp21_ = gtk_list_box_get_row_at_index (_tmp20_, 0);
#line 96 "../src/MainView.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 96 "../src/MainView.vala"
	first_row = _tmp22_;
#line 97 "../src/MainView.vala"
	_tmp23_ = first_row;
#line 97 "../src/MainView.vala"
	if (_tmp23_ != NULL) {
#line 549 "MainView.c"
		GtkListBox* _tmp24_;
		GtkListBoxRow* _tmp25_;
		GtkListBox* _tmp26_;
		GtkListBoxRow* _tmp27_;
#line 98 "../src/MainView.vala"
		_tmp24_ = self->priv->list_box;
#line 98 "../src/MainView.vala"
		_tmp25_ = first_row;
#line 98 "../src/MainView.vala"
		gtk_list_box_select_row (_tmp24_, _tmp25_);
#line 99 "../src/MainView.vala"
		_tmp26_ = self->priv->list_box;
#line 99 "../src/MainView.vala"
		_tmp27_ = first_row;
#line 99 "../src/MainView.vala"
		g_signal_emit_by_name (_tmp26_, "row-activated", _tmp27_);
#line 566 "MainView.c"
	}
#line 102 "../src/MainView.vala"
	bluetooth_main_view_update_description (self);
#line 104 "../src/MainView.vala"
	_tmp28_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 104 "../src/MainView.vala"
	_tmp29_ = _tmp28_;
#line 104 "../src/MainView.vala"
	_tmp30_ = self->priv->_manager;
#line 104 "../src/MainView.vala"
	_tmp31_ = bluetooth_services_object_manager_get_is_powered (_tmp30_);
#line 104 "../src/MainView.vala"
	_tmp32_ = _tmp31_;
#line 104 "../src/MainView.vala"
	gtk_switch_set_active (_tmp29_, _tmp32_);
#line 107 "../src/MainView.vala"
	_tmp33_ = self->priv->_manager;
#line 107 "../src/MainView.vala"
	g_signal_connect_object (_tmp33_, "device-added", (GCallback) ___lambda27__bluetooth_services_object_manager_device_added, self, 0);
#line 117 "../src/MainView.vala"
	_tmp34_ = self->priv->_manager;
#line 117 "../src/MainView.vala"
	g_signal_connect_object (_tmp34_, "device-removed", (GCallback) ___lambda28__bluetooth_services_object_manager_device_removed, self, G_CONNECT_AFTER);
#line 126 "../src/MainView.vala"
	_tmp35_ = self->priv->_manager;
#line 126 "../src/MainView.vala"
	g_signal_connect_object (_tmp35_, "adapter-added", (GCallback) ___lambda29__bluetooth_services_object_manager_adapter_added, self, 0);
#line 130 "../src/MainView.vala"
	_tmp36_ = self->priv->_manager;
#line 130 "../src/MainView.vala"
	g_signal_connect_object (_tmp36_, "adapter-removed", (GCallback) ___lambda30__bluetooth_services_object_manager_adapter_removed, self, 0);
#line 138 "../src/MainView.vala"
	_tmp37_ = self->priv->_manager;
#line 138 "../src/MainView.vala"
	g_signal_connect_object ((GObject*) _tmp37_, "notify::discoverable", (GCallback) ___lambda31__g_object_notify, self, 0);
#line 142 "../src/MainView.vala"
	_tmp38_ = self->priv->_manager;
#line 142 "../src/MainView.vala"
	g_signal_connect_object ((GObject*) _tmp38_, "notify::is-powered", (GCallback) ___lambda32__g_object_notify, self, 0);
#line 146 "../src/MainView.vala"
	_tmp39_ = self->priv->_manager;
#line 146 "../src/MainView.vala"
	_tmp40_ = self->priv->overlaybar;
#line 146 "../src/MainView.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp39_, "is-discovering", (GObject*) _tmp40_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 147 "../src/MainView.vala"
	_tmp41_ = self->priv->_manager;
#line 147 "../src/MainView.vala"
	_tmp42_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 147 "../src/MainView.vala"
	_tmp43_ = _tmp42_;
#line 147 "../src/MainView.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp41_, "is-powered", (GObject*) _tmp43_, "active", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 149 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 89 "../src/MainView.vala"
	_g_object_unref0 (first_row);
#line 624 "MainView.c"
}

static void
bluetooth_main_view_update_description (BluetoothMainView* self)
{
	gchar* name = NULL;
	BluetoothServicesObjectManager* _tmp0_;
	gchar* _tmp1_;
	gboolean powered = FALSE;
	BluetoothServicesObjectManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 152 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/MainView.vala"
	_tmp0_ = self->priv->_manager;
#line 153 "../src/MainView.vala"
	_tmp1_ = bluetooth_services_object_manager_get_name (_tmp0_);
#line 153 "../src/MainView.vala"
	name = _tmp1_;
#line 154 "../src/MainView.vala"
	_tmp2_ = self->priv->_manager;
#line 154 "../src/MainView.vala"
	_tmp3_ = bluetooth_services_object_manager_get_is_powered (_tmp2_);
#line 154 "../src/MainView.vala"
	_tmp4_ = _tmp3_;
#line 154 "../src/MainView.vala"
	powered = _tmp4_;
#line 155 "../src/MainView.vala"
	if (powered) {
#line 656 "MainView.c"
		BluetoothServicesObjectManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 155 "../src/MainView.vala"
		_tmp6_ = self->priv->_manager;
#line 155 "../src/MainView.vala"
		_tmp7_ = bluetooth_services_object_manager_get_discoverable (_tmp6_);
#line 155 "../src/MainView.vala"
		_tmp8_ = _tmp7_;
#line 155 "../src/MainView.vala"
		_tmp5_ = _tmp8_;
#line 668 "MainView.c"
	} else {
#line 155 "../src/MainView.vala"
		_tmp5_ = FALSE;
#line 672 "MainView.c"
	}
#line 155 "../src/MainView.vala"
	if (_tmp5_) {
#line 676 "MainView.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 157 "../src/MainView.vala"
		_tmp10_ = name;
#line 157 "../src/MainView.vala"
		_tmp9_ = _tmp10_;
#line 157 "../src/MainView.vala"
		if (_tmp9_ == NULL) {
#line 157 "../src/MainView.vala"
			_tmp9_ = _ ("Unknown");
#line 689 "MainView.c"
		}
#line 157 "../src/MainView.vala"
		_tmp11_ = g_strdup_printf (_ ("Now discoverable as \"%s\". Not discoverable when this page is closed"), _tmp9_);
#line 157 "../src/MainView.vala"
		_tmp12_ = _tmp11_;
#line 157 "../src/MainView.vala"
		granite_simple_settings_page_set_description ((GraniteSimpleSettingsPage*) self, _tmp12_);
#line 157 "../src/MainView.vala"
		_g_free0 (_tmp12_);
#line 699 "MainView.c"
	} else {
#line 158 "../src/MainView.vala"
		if (!powered) {
#line 159 "../src/MainView.vala"
			granite_simple_settings_page_set_description ((GraniteSimpleSettingsPage*) self, _ ("Not discoverable while Bluetooth is powered off"));
#line 705 "MainView.c"
		} else {
#line 161 "../src/MainView.vala"
			granite_simple_settings_page_set_description ((GraniteSimpleSettingsPage*) self, _ ("Not discoverable"));
#line 709 "MainView.c"
		}
	}
#line 164 "../src/MainView.vala"
	if (powered) {
#line 165 "../src/MainView.vala"
		granite_simple_settings_page_set_icon_name ((GraniteSimpleSettingsPage*) self, "bluetooth");
#line 716 "MainView.c"
	} else {
#line 167 "../src/MainView.vala"
		granite_simple_settings_page_set_icon_name ((GraniteSimpleSettingsPage*) self, "bluetooth-disabled");
#line 720 "MainView.c"
	}
#line 152 "../src/MainView.vala"
	_g_free0 (name);
#line 724 "MainView.c"
}

static gint
bluetooth_main_view_compare_rows (BluetoothDeviceRow* row1,
                                  BluetoothDeviceRow* row2,
                                  BluetoothMainView* self)
{
	BluetoothServicesDevice* device1 = NULL;
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	BluetoothServicesDevice* device2 = NULL;
	BluetoothServicesDevice* _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BluetoothServicesDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp11_ = FALSE;
	BluetoothServicesDevice* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp18_ = FALSE;
	BluetoothServicesDevice* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp25_ = FALSE;
	BluetoothServicesDevice* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp32_ = FALSE;
	BluetoothServicesDevice* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp42_ = FALSE;
	BluetoothServicesDevice* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gboolean _tmp47_;
	gchar* _tmp52_ = NULL;
	BluetoothServicesDevice* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* name1 = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_ = NULL;
	BluetoothServicesDevice* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* name2 = NULL;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gint result;
#line 172 "../src/MainView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 172 "../src/MainView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 172 "../src/MainView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 173 "../src/MainView.vala"
	_tmp0_ = bluetooth_device_row_get_device (row1);
#line 173 "../src/MainView.vala"
	_tmp1_ = _tmp0_;
#line 173 "../src/MainView.vala"
	device1 = _tmp1_;
#line 174 "../src/MainView.vala"
	_tmp2_ = bluetooth_device_row_get_device (row2);
#line 174 "../src/MainView.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/MainView.vala"
	device2 = _tmp3_;
#line 175 "../src/MainView.vala"
	_tmp5_ = device1;
#line 175 "../src/MainView.vala"
	_tmp6_ = bluetooth_services_device_get_paired (_tmp5_);
#line 175 "../src/MainView.vala"
	_tmp7_ = _tmp6_;
#line 175 "../src/MainView.vala"
	if (_tmp7_) {
#line 807 "MainView.c"
		BluetoothServicesDevice* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 175 "../src/MainView.vala"
		_tmp8_ = device2;
#line 175 "../src/MainView.vala"
		_tmp9_ = bluetooth_services_device_get_paired (_tmp8_);
#line 175 "../src/MainView.vala"
		_tmp10_ = _tmp9_;
#line 175 "../src/MainView.vala"
		_tmp4_ = !_tmp10_;
#line 819 "MainView.c"
	} else {
#line 175 "../src/MainView.vala"
		_tmp4_ = FALSE;
#line 823 "MainView.c"
	}
#line 175 "../src/MainView.vala"
	if (_tmp4_) {
#line 176 "../src/MainView.vala"
		result = -1;
#line 176 "../src/MainView.vala"
		return result;
#line 831 "MainView.c"
	}
#line 179 "../src/MainView.vala"
	_tmp12_ = device1;
#line 179 "../src/MainView.vala"
	_tmp13_ = bluetooth_services_device_get_paired (_tmp12_);
#line 179 "../src/MainView.vala"
	_tmp14_ = _tmp13_;
#line 179 "../src/MainView.vala"
	if (!_tmp14_) {
#line 841 "MainView.c"
		BluetoothServicesDevice* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 179 "../src/MainView.vala"
		_tmp15_ = device2;
#line 179 "../src/MainView.vala"
		_tmp16_ = bluetooth_services_device_get_paired (_tmp15_);
#line 179 "../src/MainView.vala"
		_tmp17_ = _tmp16_;
#line 179 "../src/MainView.vala"
		_tmp11_ = _tmp17_;
#line 853 "MainView.c"
	} else {
#line 179 "../src/MainView.vala"
		_tmp11_ = FALSE;
#line 857 "MainView.c"
	}
#line 179 "../src/MainView.vala"
	if (_tmp11_) {
#line 180 "../src/MainView.vala"
		result = 1;
#line 180 "../src/MainView.vala"
		return result;
#line 865 "MainView.c"
	}
#line 183 "../src/MainView.vala"
	_tmp19_ = device1;
#line 183 "../src/MainView.vala"
	_tmp20_ = bluetooth_services_device_get_connected (_tmp19_);
#line 183 "../src/MainView.vala"
	_tmp21_ = _tmp20_;
#line 183 "../src/MainView.vala"
	if (_tmp21_) {
#line 875 "MainView.c"
		BluetoothServicesDevice* _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 183 "../src/MainView.vala"
		_tmp22_ = device2;
#line 183 "../src/MainView.vala"
		_tmp23_ = bluetooth_services_device_get_connected (_tmp22_);
#line 183 "../src/MainView.vala"
		_tmp24_ = _tmp23_;
#line 183 "../src/MainView.vala"
		_tmp18_ = !_tmp24_;
#line 887 "MainView.c"
	} else {
#line 183 "../src/MainView.vala"
		_tmp18_ = FALSE;
#line 891 "MainView.c"
	}
#line 183 "../src/MainView.vala"
	if (_tmp18_) {
#line 184 "../src/MainView.vala"
		result = -1;
#line 184 "../src/MainView.vala"
		return result;
#line 899 "MainView.c"
	}
#line 187 "../src/MainView.vala"
	_tmp26_ = device1;
#line 187 "../src/MainView.vala"
	_tmp27_ = bluetooth_services_device_get_connected (_tmp26_);
#line 187 "../src/MainView.vala"
	_tmp28_ = _tmp27_;
#line 187 "../src/MainView.vala"
	if (!_tmp28_) {
#line 909 "MainView.c"
		BluetoothServicesDevice* _tmp29_;
		gboolean _tmp30_;
		gboolean _tmp31_;
#line 187 "../src/MainView.vala"
		_tmp29_ = device2;
#line 187 "../src/MainView.vala"
		_tmp30_ = bluetooth_services_device_get_connected (_tmp29_);
#line 187 "../src/MainView.vala"
		_tmp31_ = _tmp30_;
#line 187 "../src/MainView.vala"
		_tmp25_ = _tmp31_;
#line 921 "MainView.c"
	} else {
#line 187 "../src/MainView.vala"
		_tmp25_ = FALSE;
#line 925 "MainView.c"
	}
#line 187 "../src/MainView.vala"
	if (_tmp25_) {
#line 188 "../src/MainView.vala"
		result = 1;
#line 188 "../src/MainView.vala"
		return result;
#line 933 "MainView.c"
	}
#line 191 "../src/MainView.vala"
	_tmp33_ = device1;
#line 191 "../src/MainView.vala"
	_tmp34_ = bluetooth_services_device_get_name (_tmp33_);
#line 191 "../src/MainView.vala"
	_tmp35_ = _tmp34_;
#line 191 "../src/MainView.vala"
	_tmp36_ = _tmp35_;
#line 191 "../src/MainView.vala"
	_tmp37_ = _tmp36_ != NULL;
#line 191 "../src/MainView.vala"
	_g_free0 (_tmp36_);
#line 191 "../src/MainView.vala"
	if (_tmp37_) {
#line 949 "MainView.c"
		BluetoothServicesDevice* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 191 "../src/MainView.vala"
		_tmp38_ = device2;
#line 191 "../src/MainView.vala"
		_tmp39_ = bluetooth_services_device_get_name (_tmp38_);
#line 191 "../src/MainView.vala"
		_tmp40_ = _tmp39_;
#line 191 "../src/MainView.vala"
		_tmp41_ = _tmp40_;
#line 191 "../src/MainView.vala"
		_tmp32_ = _tmp41_ == NULL;
#line 191 "../src/MainView.vala"
		_g_free0 (_tmp41_);
#line 966 "MainView.c"
	} else {
#line 191 "../src/MainView.vala"
		_tmp32_ = FALSE;
#line 970 "MainView.c"
	}
#line 191 "../src/MainView.vala"
	if (_tmp32_) {
#line 192 "../src/MainView.vala"
		result = -1;
#line 192 "../src/MainView.vala"
		return result;
#line 978 "MainView.c"
	}
#line 195 "../src/MainView.vala"
	_tmp43_ = device1;
#line 195 "../src/MainView.vala"
	_tmp44_ = bluetooth_services_device_get_name (_tmp43_);
#line 195 "../src/MainView.vala"
	_tmp45_ = _tmp44_;
#line 195 "../src/MainView.vala"
	_tmp46_ = _tmp45_;
#line 195 "../src/MainView.vala"
	_tmp47_ = _tmp46_ == NULL;
#line 195 "../src/MainView.vala"
	_g_free0 (_tmp46_);
#line 195 "../src/MainView.vala"
	if (_tmp47_) {
#line 994 "MainView.c"
		BluetoothServicesDevice* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 195 "../src/MainView.vala"
		_tmp48_ = device2;
#line 195 "../src/MainView.vala"
		_tmp49_ = bluetooth_services_device_get_name (_tmp48_);
#line 195 "../src/MainView.vala"
		_tmp50_ = _tmp49_;
#line 195 "../src/MainView.vala"
		_tmp51_ = _tmp50_;
#line 195 "../src/MainView.vala"
		_tmp42_ = _tmp51_ != NULL;
#line 195 "../src/MainView.vala"
		_g_free0 (_tmp51_);
#line 1011 "MainView.c"
	} else {
#line 195 "../src/MainView.vala"
		_tmp42_ = FALSE;
#line 1015 "MainView.c"
	}
#line 195 "../src/MainView.vala"
	if (_tmp42_) {
#line 196 "../src/MainView.vala"
		result = 1;
#line 196 "../src/MainView.vala"
		return result;
#line 1023 "MainView.c"
	}
#line 199 "../src/MainView.vala"
	_tmp53_ = device1;
#line 199 "../src/MainView.vala"
	_tmp54_ = bluetooth_services_device_get_name (_tmp53_);
#line 199 "../src/MainView.vala"
	_tmp55_ = _tmp54_;
#line 199 "../src/MainView.vala"
	_tmp52_ = _tmp55_;
#line 199 "../src/MainView.vala"
	if (_tmp52_ == NULL) {
#line 1035 "MainView.c"
		BluetoothServicesDevice* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
#line 199 "../src/MainView.vala"
		_tmp56_ = device1;
#line 199 "../src/MainView.vala"
		_tmp57_ = bluetooth_services_device_get_address (_tmp56_);
#line 199 "../src/MainView.vala"
		_tmp58_ = _tmp57_;
#line 199 "../src/MainView.vala"
		_g_free0 (_tmp52_);
#line 199 "../src/MainView.vala"
		_tmp52_ = _tmp58_;
#line 1049 "MainView.c"
	}
#line 199 "../src/MainView.vala"
	_tmp59_ = _tmp52_;
#line 199 "../src/MainView.vala"
	_tmp52_ = NULL;
#line 199 "../src/MainView.vala"
	name1 = _tmp59_;
#line 200 "../src/MainView.vala"
	_tmp61_ = device2;
#line 200 "../src/MainView.vala"
	_tmp62_ = bluetooth_services_device_get_name (_tmp61_);
#line 200 "../src/MainView.vala"
	_tmp63_ = _tmp62_;
#line 200 "../src/MainView.vala"
	_tmp60_ = _tmp63_;
#line 200 "../src/MainView.vala"
	if (_tmp60_ == NULL) {
#line 1067 "MainView.c"
		BluetoothServicesDevice* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
#line 200 "../src/MainView.vala"
		_tmp64_ = device2;
#line 200 "../src/MainView.vala"
		_tmp65_ = bluetooth_services_device_get_address (_tmp64_);
#line 200 "../src/MainView.vala"
		_tmp66_ = _tmp65_;
#line 200 "../src/MainView.vala"
		_g_free0 (_tmp60_);
#line 200 "../src/MainView.vala"
		_tmp60_ = _tmp66_;
#line 1081 "MainView.c"
	}
#line 200 "../src/MainView.vala"
	_tmp67_ = _tmp60_;
#line 200 "../src/MainView.vala"
	_tmp60_ = NULL;
#line 200 "../src/MainView.vala"
	name2 = _tmp67_;
#line 201 "../src/MainView.vala"
	_tmp68_ = name1;
#line 201 "../src/MainView.vala"
	_tmp69_ = name2;
#line 201 "../src/MainView.vala"
	result = g_utf8_collate (_tmp68_, _tmp69_);
#line 201 "../src/MainView.vala"
	_g_free0 (name2);
#line 201 "../src/MainView.vala"
	_g_free0 (_tmp60_);
#line 201 "../src/MainView.vala"
	_g_free0 (name1);
#line 201 "../src/MainView.vala"
	_g_free0 (_tmp52_);
#line 201 "../src/MainView.vala"
	return result;
#line 1105 "MainView.c"
}

static void
bluetooth_main_view_title_rows (BluetoothDeviceRow* row1,
                                BluetoothDeviceRow* row2,
                                BluetoothMainView* self)
{
	gboolean _tmp0_ = FALSE;
#line 205 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/MainView.vala"
	g_return_if_fail (row1 != NULL);
#line 206 "../src/MainView.vala"
	if (row2 == NULL) {
#line 1120 "MainView.c"
		BluetoothServicesDevice* _tmp1_;
		BluetoothServicesDevice* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 206 "../src/MainView.vala"
		_tmp1_ = bluetooth_device_row_get_device (row1);
#line 206 "../src/MainView.vala"
		_tmp2_ = _tmp1_;
#line 206 "../src/MainView.vala"
		_tmp3_ = bluetooth_services_device_get_paired (_tmp2_);
#line 206 "../src/MainView.vala"
		_tmp4_ = _tmp3_;
#line 206 "../src/MainView.vala"
		_tmp0_ = _tmp4_;
#line 1135 "MainView.c"
	} else {
#line 206 "../src/MainView.vala"
		_tmp0_ = FALSE;
#line 1139 "MainView.c"
	}
#line 206 "../src/MainView.vala"
	if (_tmp0_) {
#line 1143 "MainView.c"
		GtkLabel* label = NULL;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		GtkStyleContext* _tmp9_;
		GtkLabel* _tmp10_;
#line 207 "../src/MainView.vala"
		_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Paired Devices"));
#line 207 "../src/MainView.vala"
		g_object_ref_sink (_tmp5_);
#line 207 "../src/MainView.vala"
		label = _tmp5_;
#line 208 "../src/MainView.vala"
		_tmp6_ = label;
#line 208 "../src/MainView.vala"
		gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 209 "../src/MainView.vala"
		_tmp7_ = label;
#line 209 "../src/MainView.vala"
		g_object_set ((GtkWidget*) _tmp7_, "margin", 3, NULL);
#line 210 "../src/MainView.vala"
		_tmp8_ = label;
#line 210 "../src/MainView.vala"
		_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 210 "../src/MainView.vala"
		gtk_style_context_add_class (_tmp9_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 211 "../src/MainView.vala"
		_tmp10_ = label;
#line 211 "../src/MainView.vala"
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp10_);
#line 206 "../src/MainView.vala"
		_g_object_unref0 (label);
#line 1177 "MainView.c"
	} else {
		gboolean _tmp11_ = FALSE;
#line 212 "../src/MainView.vala"
		if (row2 == NULL) {
#line 212 "../src/MainView.vala"
			_tmp11_ = TRUE;
#line 1184 "MainView.c"
		} else {
			BluetoothServicesDevice* _tmp12_;
			BluetoothServicesDevice* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			BluetoothServicesDevice* _tmp16_;
			BluetoothServicesDevice* _tmp17_;
			gboolean _tmp18_;
			gboolean _tmp19_;
#line 212 "../src/MainView.vala"
			_tmp12_ = bluetooth_device_row_get_device (row1);
#line 212 "../src/MainView.vala"
			_tmp13_ = _tmp12_;
#line 212 "../src/MainView.vala"
			_tmp14_ = bluetooth_services_device_get_paired (_tmp13_);
#line 212 "../src/MainView.vala"
			_tmp15_ = _tmp14_;
#line 212 "../src/MainView.vala"
			_tmp16_ = bluetooth_device_row_get_device (row2);
#line 212 "../src/MainView.vala"
			_tmp17_ = _tmp16_;
#line 212 "../src/MainView.vala"
			_tmp18_ = bluetooth_services_device_get_paired (_tmp17_);
#line 212 "../src/MainView.vala"
			_tmp19_ = _tmp18_;
#line 212 "../src/MainView.vala"
			_tmp11_ = _tmp15_ != _tmp19_;
#line 1212 "MainView.c"
		}
#line 212 "../src/MainView.vala"
		if (_tmp11_) {
#line 1216 "MainView.c"
			GtkLabel* label = NULL;
			GtkLabel* _tmp20_;
			GtkLabel* _tmp21_;
			GtkLabel* _tmp22_;
			GtkLabel* _tmp23_;
			GtkStyleContext* _tmp24_;
			GtkLabel* _tmp25_;
#line 214 "../src/MainView.vala"
			_tmp20_ = (GtkLabel*) gtk_label_new (_ ("Nearby Devices"));
#line 214 "../src/MainView.vala"
			g_object_ref_sink (_tmp20_);
#line 214 "../src/MainView.vala"
			label = _tmp20_;
#line 215 "../src/MainView.vala"
			_tmp21_ = label;
#line 215 "../src/MainView.vala"
			gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
#line 216 "../src/MainView.vala"
			_tmp22_ = label;
#line 216 "../src/MainView.vala"
			gtk_label_set_xalign (_tmp22_, (gfloat) 0);
#line 217 "../src/MainView.vala"
			_tmp23_ = label;
#line 217 "../src/MainView.vala"
			_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
#line 217 "../src/MainView.vala"
			gtk_style_context_add_class (_tmp24_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 218 "../src/MainView.vala"
			_tmp25_ = label;
#line 218 "../src/MainView.vala"
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp25_);
#line 212 "../src/MainView.vala"
			_g_object_unref0 (label);
#line 1250 "MainView.c"
		} else {
#line 220 "../src/MainView.vala"
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, NULL);
#line 1254 "MainView.c"
		}
	}
}

BluetoothServicesObjectManager*
bluetooth_main_view_get_manager (BluetoothMainView* self)
{
	BluetoothServicesObjectManager* result;
	BluetoothServicesObjectManager* _tmp0_;
#line 26 "../src/MainView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/MainView.vala"
	_tmp0_ = self->priv->_manager;
#line 26 "../src/MainView.vala"
	result = _tmp0_;
#line 26 "../src/MainView.vala"
	return result;
#line 1272 "MainView.c"
}

void
bluetooth_main_view_set_manager (BluetoothMainView* self,
                                 BluetoothServicesObjectManager* value)
{
	BluetoothServicesObjectManager* old_value;
#line 26 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/MainView.vala"
	old_value = bluetooth_main_view_get_manager (self);
#line 26 "../src/MainView.vala"
	if (old_value != value) {
#line 1286 "MainView.c"
		BluetoothServicesObjectManager* _tmp0_;
#line 26 "../src/MainView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/MainView.vala"
		_g_object_unref0 (self->priv->_manager);
#line 26 "../src/MainView.vala"
		self->priv->_manager = _tmp0_;
#line 26 "../src/MainView.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY]);
#line 1296 "MainView.c"
	}
}

static void
_bluetooth_main_view_complete_setup_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 79 "../src/MainView.vala"
	bluetooth_main_view_complete_setup ((BluetoothMainView*) self);
#line 1307 "MainView.c"
}

static void
_bluetooth_main_view___lambda33_ (BluetoothMainView* self)
{
	BluetoothServicesObjectManager* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 83 "../src/MainView.vala"
	_tmp0_ = self->priv->_manager;
#line 83 "../src/MainView.vala"
	_tmp1_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 83 "../src/MainView.vala"
	_tmp2_ = _tmp1_;
#line 83 "../src/MainView.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 83 "../src/MainView.vala"
	_tmp4_ = _tmp3_;
#line 83 "../src/MainView.vala"
	bluetooth_services_object_manager_set_global_state (_tmp0_, _tmp4_, NULL, NULL);
#line 1330 "MainView.c"
}

static void
__bluetooth_main_view___lambda33__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 82 "../src/MainView.vala"
	_bluetooth_main_view___lambda33_ ((BluetoothMainView*) self);
#line 1340 "MainView.c"
}

static GObject *
bluetooth_main_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothMainView * self;
	GraniteWidgetsAlertView* empty_alert = NULL;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GtkListBox* _tmp7_;
	GtkListBox* _tmp8_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	GtkScrolledWindow* _tmp11_;
	GtkListBox* _tmp12_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp13_;
	GtkOverlay* _tmp14_;
	GtkScrolledWindow* _tmp15_;
	GtkOverlay* _tmp16_;
	gchar* _tmp17_;
	GraniteWidgetsOverlayBar* _tmp18_ = NULL;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp19_;
	GtkFrame* _tmp20_;
	GtkOverlay* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkFrame* _tmp28_;
	BluetoothServicesObjectManager* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	GtkSwitch* _tmp33_;
	GtkSwitch* _tmp34_;
#line 40 "../src/MainView.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_main_view_parent_class);
#line 40 "../src/MainView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/MainView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
#line 41 "../src/MainView.vala"
	_tmp0_ = granite_widgets_alert_view_new (_ ("No Devices Found"), _ ("Please ensure that your devices are visible and ready for pairing."), "");
#line 41 "../src/MainView.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/MainView.vala"
	empty_alert = _tmp0_;
#line 46 "../src/MainView.vala"
	_tmp1_ = empty_alert;
#line 46 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 48 "../src/MainView.vala"
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
#line 48 "../src/MainView.vala"
	g_object_ref_sink (_tmp2_);
#line 48 "../src/MainView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 48 "../src/MainView.vala"
	self->priv->list_box = _tmp2_;
#line 49 "../src/MainView.vala"
	_tmp3_ = self->priv->list_box;
#line 49 "../src/MainView.vala"
	gtk_list_box_set_sort_func (_tmp3_, (GtkListBoxSortFunc) bluetooth_main_view_compare_rows, g_object_ref (self), g_object_unref);
#line 50 "../src/MainView.vala"
	_tmp4_ = self->priv->list_box;
#line 50 "../src/MainView.vala"
	gtk_list_box_set_header_func (_tmp4_, (GtkListBoxUpdateHeaderFunc) bluetooth_main_view_title_rows, g_object_ref (self), g_object_unref);
#line 51 "../src/MainView.vala"
	_tmp5_ = self->priv->list_box;
#line 51 "../src/MainView.vala"
	_tmp6_ = empty_alert;
#line 51 "../src/MainView.vala"
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
#line 52 "../src/MainView.vala"
	_tmp7_ = self->priv->list_box;
#line 52 "../src/MainView.vala"
	gtk_list_box_set_selection_mode (_tmp7_, GTK_SELECTION_BROWSE);
#line 53 "../src/MainView.vala"
	_tmp8_ = self->priv->list_box;
#line 53 "../src/MainView.vala"
	gtk_list_box_set_activate_on_single_click (_tmp8_, TRUE);
#line 55 "../src/MainView.vala"
	_tmp9_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 55 "../src/MainView.vala"
	g_object_ref_sink (_tmp9_);
#line 55 "../src/MainView.vala"
	scrolled = _tmp9_;
#line 56 "../src/MainView.vala"
	_tmp10_ = scrolled;
#line 56 "../src/MainView.vala"
	g_object_set ((GtkWidget*) _tmp10_, "expand", TRUE, NULL);
#line 57 "../src/MainView.vala"
	_tmp11_ = scrolled;
#line 57 "../src/MainView.vala"
	_tmp12_ = self->priv->list_box;
#line 57 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 59 "../src/MainView.vala"
	_tmp13_ = (GtkOverlay*) gtk_overlay_new ();
#line 59 "../src/MainView.vala"
	g_object_ref_sink (_tmp13_);
#line 59 "../src/MainView.vala"
	overlay = _tmp13_;
#line 60 "../src/MainView.vala"
	_tmp14_ = overlay;
#line 60 "../src/MainView.vala"
	_tmp15_ = scrolled;
#line 60 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 62 "../src/MainView.vala"
	_tmp16_ = overlay;
#line 62 "../src/MainView.vala"
	_tmp17_ = g_strdup (_ ("Discovering"));
#line 62 "../src/MainView.vala"
	_tmp18_ = granite_widgets_overlay_bar_new (_tmp16_);
#line 62 "../src/MainView.vala"
	granite_widgets_overlay_bar_set_label (_tmp18_, _tmp17_);
#line 62 "../src/MainView.vala"
	_g_free0 (_tmp17_);
#line 62 "../src/MainView.vala"
	granite_widgets_overlay_bar_set_active (_tmp18_, TRUE);
#line 62 "../src/MainView.vala"
	g_object_ref_sink (_tmp18_);
#line 62 "../src/MainView.vala"
	_g_object_unref0 (self->priv->overlaybar);
#line 62 "../src/MainView.vala"
	self->priv->overlaybar = _tmp18_;
#line 67 "../src/MainView.vala"
	_tmp19_ = (GtkFrame*) gtk_frame_new (NULL);
#line 67 "../src/MainView.vala"
	g_object_ref_sink (_tmp19_);
#line 67 "../src/MainView.vala"
	frame = _tmp19_;
#line 68 "../src/MainView.vala"
	_tmp20_ = frame;
#line 68 "../src/MainView.vala"
	_tmp21_ = overlay;
#line 68 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 70 "../src/MainView.vala"
	_tmp22_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 70 "../src/MainView.vala"
	_tmp23_ = _tmp22_;
#line 70 "../src/MainView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_VERTICAL);
#line 71 "../src/MainView.vala"
	_tmp24_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 71 "../src/MainView.vala"
	_tmp25_ = _tmp24_;
#line 71 "../src/MainView.vala"
	gtk_grid_set_row_spacing (_tmp25_, 0);
#line 72 "../src/MainView.vala"
	_tmp26_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 72 "../src/MainView.vala"
	_tmp27_ = _tmp26_;
#line 72 "../src/MainView.vala"
	_tmp28_ = frame;
#line 72 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 74 "../src/MainView.vala"
	g_object_set ((GtkWidget*) self, "margin", 12, NULL);
#line 76 "../src/MainView.vala"
	_tmp29_ = self->priv->_manager;
#line 76 "../src/MainView.vala"
	_tmp30_ = bluetooth_services_object_manager_get_retrieve_finished (_tmp29_);
#line 76 "../src/MainView.vala"
	_tmp31_ = _tmp30_;
#line 76 "../src/MainView.vala"
	if (_tmp31_) {
#line 77 "../src/MainView.vala"
		bluetooth_main_view_complete_setup (self);
#line 1525 "MainView.c"
	} else {
		BluetoothServicesObjectManager* _tmp32_;
#line 79 "../src/MainView.vala"
		_tmp32_ = self->priv->_manager;
#line 79 "../src/MainView.vala"
		g_signal_connect_object ((GObject*) _tmp32_, "notify::retrieve-finished", (GCallback) _bluetooth_main_view_complete_setup_g_object_notify, self, 0);
#line 1532 "MainView.c"
	}
#line 82 "../src/MainView.vala"
	_tmp33_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 82 "../src/MainView.vala"
	_tmp34_ = _tmp33_;
#line 82 "../src/MainView.vala"
	g_signal_connect_object ((GObject*) _tmp34_, "notify::active", (GCallback) __bluetooth_main_view___lambda33__g_object_notify, self, 0);
#line 86 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 40 "../src/MainView.vala"
	_g_object_unref0 (frame);
#line 40 "../src/MainView.vala"
	_g_object_unref0 (overlay);
#line 40 "../src/MainView.vala"
	_g_object_unref0 (scrolled);
#line 40 "../src/MainView.vala"
	_g_object_unref0 (empty_alert);
#line 40 "../src/MainView.vala"
	return obj;
#line 1552 "MainView.c"
}

static void
bluetooth_main_view_class_init (BluetoothMainViewClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/MainView.vala"
	bluetooth_main_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/MainView.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothMainView_private_offset);
#line 22 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_main_view_get_property;
#line 22 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_main_view_set_property;
#line 22 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_main_view_constructor;
#line 22 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_main_view_finalize;
#line 22 "../src/MainView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY, bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY] = g_param_spec_object ("manager", "manager", "manager", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../src/MainView.vala"
	bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_QUIT_PLUG_SIGNAL] = g_signal_new ("quit-plug", BLUETOOTH_TYPE_MAIN_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1575 "MainView.c"
}

static void
bluetooth_main_view_instance_init (BluetoothMainView * self,
                                   gpointer klass)
{
#line 22 "../src/MainView.vala"
	self->priv = bluetooth_main_view_get_instance_private (self);
#line 1584 "MainView.c"
}

static void
bluetooth_main_view_finalize (GObject * obj)
{
	BluetoothMainView * self;
#line 22 "../src/MainView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
#line 23 "../src/MainView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 24 "../src/MainView.vala"
	_g_object_unref0 (self->priv->overlaybar);
#line 26 "../src/MainView.vala"
	_g_object_unref0 (self->priv->_manager);
#line 22 "../src/MainView.vala"
	G_OBJECT_CLASS (bluetooth_main_view_parent_class)->finalize (obj);
#line 1601 "MainView.c"
}

static GType
bluetooth_main_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothMainViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_main_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothMainView), 0, (GInstanceInitFunc) bluetooth_main_view_instance_init, NULL };
	GType bluetooth_main_view_type_id;
	bluetooth_main_view_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "BluetoothMainView", &g_define_type_info, 0);
	BluetoothMainView_private_offset = g_type_add_instance_private (bluetooth_main_view_type_id, sizeof (BluetoothMainViewPrivate));
	return bluetooth_main_view_type_id;
}

GType
bluetooth_main_view_get_type (void)
{
	static volatile gsize bluetooth_main_view_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_main_view_type_id__once)) {
		GType bluetooth_main_view_type_id;
		bluetooth_main_view_type_id = bluetooth_main_view_get_type_once ();
		g_once_init_leave (&bluetooth_main_view_type_id__once, bluetooth_main_view_type_id);
	}
	return bluetooth_main_view_type_id__once;
}

static void
_vala_bluetooth_main_view_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BluetoothMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
#line 22 "../src/MainView.vala"
	switch (property_id) {
#line 22 "../src/MainView.vala"
		case BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY:
#line 22 "../src/MainView.vala"
		g_value_set_object (value, bluetooth_main_view_get_manager (self));
#line 22 "../src/MainView.vala"
		break;
#line 1642 "MainView.c"
		default:
#line 22 "../src/MainView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/MainView.vala"
		break;
#line 1648 "MainView.c"
	}
}

static void
_vala_bluetooth_main_view_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BluetoothMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
#line 22 "../src/MainView.vala"
	switch (property_id) {
#line 22 "../src/MainView.vala"
		case BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY:
#line 22 "../src/MainView.vala"
		bluetooth_main_view_set_manager (self, g_value_get_object (value));
#line 22 "../src/MainView.vala"
		break;
#line 1668 "MainView.c"
		default:
#line 22 "../src/MainView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/MainView.vala"
		break;
#line 1674 "MainView.c"
	}
}

